<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/appengine/v1/application.proto

namespace Google\Appengine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An Application resource contains the top-level configuration of an App
 * Engine application.
 *
 * Generated from protobuf message <code>google.appengine.v1.Application</code>
 */
class Application extends \Google\Protobuf\Internal\Message
{
    /**
     * Full path to the Application resource in the API.
     * Example: `apps/myapp`.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    private $name = '';
    /**
     * Identifier of the Application resource. This identifier is equivalent
     * to the project ID of the Google Cloud Platform project where you want to
     * deploy your application.
     * Example: `myapp`.
     *
     * Generated from protobuf field <code>string id = 2;</code>
     */
    private $id = '';
    /**
     * HTTP path dispatch rules for requests to the application that do not
     * explicitly target a service or version. Rules are order-dependent.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>repeated .google.appengine.v1.UrlDispatchRule dispatch_rules = 3;</code>
     */
    private $dispatch_rules;
    /**
     * Google Apps authentication domain that controls which users can access
     * this application.
     * Defaults to open access for any Google Account.
     *
     * Generated from protobuf field <code>string auth_domain = 6;</code>
     */
    private $auth_domain = '';
    /**
     * Location from which this application will be run. Application instances
     * will run out of data centers in the chosen location, which is also where
     * all of the application's end user content is stored.
     * Defaults to `us-central`.
     * Options are:
     * `us-central` - Central US
     * `europe-west` - Western Europe
     * `us-east1` - Eastern US
     *
     * Generated from protobuf field <code>string location_id = 7;</code>
     */
    private $location_id = '';
    /**
     * Google Cloud Storage bucket that can be used for storing files
     * associated with this application. This bucket is associated with the
     * application and can be used by the gcloud deployment commands.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string code_bucket = 8;</code>
     */
    private $code_bucket = '';
    /**
     * Cookie expiration policy for this application.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>.google.protobuf.Duration default_cookie_expiration = 9;</code>
     */
    private $default_cookie_expiration = null;
    /**
     * Hostname used to reach this application, as resolved by App Engine.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string default_hostname = 11;</code>
     */
    private $default_hostname = '';
    /**
     * Google Cloud Storage bucket that can be used by this application to store
     * content.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string default_bucket = 12;</code>
     */
    private $default_bucket = '';

    public function __construct() {
        \GPBMetadata\Google\Appengine\V1\Application::initOnce();
        parent::__construct();
    }

    /**
     * Full path to the Application resource in the API.
     * Example: `apps/myapp`.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Full path to the Application resource in the API.
     * Example: `apps/myapp`.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Identifier of the Application resource. This identifier is equivalent
     * to the project ID of the Google Cloud Platform project where you want to
     * deploy your application.
     * Example: `myapp`.
     *
     * Generated from protobuf field <code>string id = 2;</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Identifier of the Application resource. This identifier is equivalent
     * to the project ID of the Google Cloud Platform project where you want to
     * deploy your application.
     * Example: `myapp`.
     *
     * Generated from protobuf field <code>string id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * HTTP path dispatch rules for requests to the application that do not
     * explicitly target a service or version. Rules are order-dependent.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>repeated .google.appengine.v1.UrlDispatchRule dispatch_rules = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getDispatchRules()
    {
        return $this->dispatch_rules;
    }

    /**
     * HTTP path dispatch rules for requests to the application that do not
     * explicitly target a service or version. Rules are order-dependent.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>repeated .google.appengine.v1.UrlDispatchRule dispatch_rules = 3;</code>
     * @param \Google\Appengine\V1\UrlDispatchRule[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setDispatchRules($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Appengine\V1\UrlDispatchRule::class);
        $this->dispatch_rules = $arr;

        return $this;
    }

    /**
     * Google Apps authentication domain that controls which users can access
     * this application.
     * Defaults to open access for any Google Account.
     *
     * Generated from protobuf field <code>string auth_domain = 6;</code>
     * @return string
     */
    public function getAuthDomain()
    {
        return $this->auth_domain;
    }

    /**
     * Google Apps authentication domain that controls which users can access
     * this application.
     * Defaults to open access for any Google Account.
     *
     * Generated from protobuf field <code>string auth_domain = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setAuthDomain($var)
    {
        GPBUtil::checkString($var, True);
        $this->auth_domain = $var;

        return $this;
    }

    /**
     * Location from which this application will be run. Application instances
     * will run out of data centers in the chosen location, which is also where
     * all of the application's end user content is stored.
     * Defaults to `us-central`.
     * Options are:
     * `us-central` - Central US
     * `europe-west` - Western Europe
     * `us-east1` - Eastern US
     *
     * Generated from protobuf field <code>string location_id = 7;</code>
     * @return string
     */
    public function getLocationId()
    {
        return $this->location_id;
    }

    /**
     * Location from which this application will be run. Application instances
     * will run out of data centers in the chosen location, which is also where
     * all of the application's end user content is stored.
     * Defaults to `us-central`.
     * Options are:
     * `us-central` - Central US
     * `europe-west` - Western Europe
     * `us-east1` - Eastern US
     *
     * Generated from protobuf field <code>string location_id = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setLocationId($var)
    {
        GPBUtil::checkString($var, True);
        $this->location_id = $var;

        return $this;
    }

    /**
     * Google Cloud Storage bucket that can be used for storing files
     * associated with this application. This bucket is associated with the
     * application and can be used by the gcloud deployment commands.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string code_bucket = 8;</code>
     * @return string
     */
    public function getCodeBucket()
    {
        return $this->code_bucket;
    }

    /**
     * Google Cloud Storage bucket that can be used for storing files
     * associated with this application. This bucket is associated with the
     * application and can be used by the gcloud deployment commands.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string code_bucket = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setCodeBucket($var)
    {
        GPBUtil::checkString($var, True);
        $this->code_bucket = $var;

        return $this;
    }

    /**
     * Cookie expiration policy for this application.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>.google.protobuf.Duration default_cookie_expiration = 9;</code>
     * @return \Google\Protobuf\Duration
     */
    public function getDefaultCookieExpiration()
    {
        return $this->default_cookie_expiration;
    }

    /**
     * Cookie expiration policy for this application.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>.google.protobuf.Duration default_cookie_expiration = 9;</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setDefaultCookieExpiration($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->default_cookie_expiration = $var;

        return $this;
    }

    /**
     * Hostname used to reach this application, as resolved by App Engine.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string default_hostname = 11;</code>
     * @return string
     */
    public function getDefaultHostname()
    {
        return $this->default_hostname;
    }

    /**
     * Hostname used to reach this application, as resolved by App Engine.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string default_hostname = 11;</code>
     * @param string $var
     * @return $this
     */
    public function setDefaultHostname($var)
    {
        GPBUtil::checkString($var, True);
        $this->default_hostname = $var;

        return $this;
    }

    /**
     * Google Cloud Storage bucket that can be used by this application to store
     * content.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string default_bucket = 12;</code>
     * @return string
     */
    public function getDefaultBucket()
    {
        return $this->default_bucket;
    }

    /**
     * Google Cloud Storage bucket that can be used by this application to store
     * content.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string default_bucket = 12;</code>
     * @param string $var
     * @return $this
     */
    public function setDefaultBucket($var)
    {
        GPBUtil::checkString($var, True);
        $this->default_bucket = $var;

        return $this;
    }

}

