<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/appengine/v1/instance.proto

namespace Google\Appengine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An Instance resource is the computing unit that App Engine uses to
 * automatically scale an application.
 *
 * Generated from protobuf message <code>google.appengine.v1.Instance</code>
 */
class Instance extends \Google\Protobuf\Internal\Message
{
    /**
     * Full path to the Instance resource in the API.
     * Example: `apps/myapp/services/default/versions/v1/instances/instance-1`.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    private $name = '';
    /**
     * Relative name of the instance within the version.
     * Example: `instance-1`.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string id = 2;</code>
     */
    private $id = '';
    /**
     * App Engine release this instance is running on.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string app_engine_release = 3;</code>
     */
    private $app_engine_release = '';
    /**
     * Availability of the instance.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>.google.appengine.v1.Instance.Availability availability = 4;</code>
     */
    private $availability = 0;
    /**
     * Name of the virtual machine where this instance lives. Only applicable
     * for instances in App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_name = 5;</code>
     */
    private $vm_name = '';
    /**
     * Zone where the virtual machine is located. Only applicable for instances
     * in App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_zone_name = 6;</code>
     */
    private $vm_zone_name = '';
    /**
     * Virtual machine ID of this instance. Only applicable for instances in
     * App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_id = 7;</code>
     */
    private $vm_id = '';
    /**
     * Time that this instance was started.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 8;</code>
     */
    private $start_time = null;
    /**
     * Number of requests since this instance was started.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int32 requests = 9;</code>
     */
    private $requests = 0;
    /**
     * Number of errors since this instance was started.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int32 errors = 10;</code>
     */
    private $errors = 0;
    /**
     * Average queries per second (QPS) over the last minute.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>float qps = 11;</code>
     */
    private $qps = 0.0;
    /**
     * Average latency (ms) over the last minute.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int32 average_latency = 12;</code>
     */
    private $average_latency = 0;
    /**
     * Total memory in use (bytes).
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int64 memory_usage = 13;</code>
     */
    private $memory_usage = 0;
    /**
     * Status of the virtual machine where this instance lives. Only applicable
     * for instances in App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_status = 14;</code>
     */
    private $vm_status = '';
    /**
     * Whether this instance is in debug mode. Only applicable for instances in
     * App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>bool vm_debug_enabled = 15;</code>
     */
    private $vm_debug_enabled = false;

    public function __construct() {
        \GPBMetadata\Google\Appengine\V1\Instance::initOnce();
        parent::__construct();
    }

    /**
     * Full path to the Instance resource in the API.
     * Example: `apps/myapp/services/default/versions/v1/instances/instance-1`.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Full path to the Instance resource in the API.
     * Example: `apps/myapp/services/default/versions/v1/instances/instance-1`.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Relative name of the instance within the version.
     * Example: `instance-1`.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string id = 2;</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Relative name of the instance within the version.
     * Example: `instance-1`.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * App Engine release this instance is running on.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string app_engine_release = 3;</code>
     * @return string
     */
    public function getAppEngineRelease()
    {
        return $this->app_engine_release;
    }

    /**
     * App Engine release this instance is running on.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string app_engine_release = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setAppEngineRelease($var)
    {
        GPBUtil::checkString($var, True);
        $this->app_engine_release = $var;

        return $this;
    }

    /**
     * Availability of the instance.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>.google.appengine.v1.Instance.Availability availability = 4;</code>
     * @return int
     */
    public function getAvailability()
    {
        return $this->availability;
    }

    /**
     * Availability of the instance.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>.google.appengine.v1.Instance.Availability availability = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setAvailability($var)
    {
        GPBUtil::checkEnum($var, \Google\Appengine\V1\Instance_Availability::class);
        $this->availability = $var;

        return $this;
    }

    /**
     * Name of the virtual machine where this instance lives. Only applicable
     * for instances in App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_name = 5;</code>
     * @return string
     */
    public function getVmName()
    {
        return $this->vm_name;
    }

    /**
     * Name of the virtual machine where this instance lives. Only applicable
     * for instances in App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_name = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setVmName($var)
    {
        GPBUtil::checkString($var, True);
        $this->vm_name = $var;

        return $this;
    }

    /**
     * Zone where the virtual machine is located. Only applicable for instances
     * in App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_zone_name = 6;</code>
     * @return string
     */
    public function getVmZoneName()
    {
        return $this->vm_zone_name;
    }

    /**
     * Zone where the virtual machine is located. Only applicable for instances
     * in App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_zone_name = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setVmZoneName($var)
    {
        GPBUtil::checkString($var, True);
        $this->vm_zone_name = $var;

        return $this;
    }

    /**
     * Virtual machine ID of this instance. Only applicable for instances in
     * App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_id = 7;</code>
     * @return string
     */
    public function getVmId()
    {
        return $this->vm_id;
    }

    /**
     * Virtual machine ID of this instance. Only applicable for instances in
     * App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_id = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setVmId($var)
    {
        GPBUtil::checkString($var, True);
        $this->vm_id = $var;

        return $this;
    }

    /**
     * Time that this instance was started.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 8;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getStartTime()
    {
        return $this->start_time;
    }

    /**
     * Time that this instance was started.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 8;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setStartTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->start_time = $var;

        return $this;
    }

    /**
     * Number of requests since this instance was started.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int32 requests = 9;</code>
     * @return int
     */
    public function getRequests()
    {
        return $this->requests;
    }

    /**
     * Number of requests since this instance was started.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int32 requests = 9;</code>
     * @param int $var
     * @return $this
     */
    public function setRequests($var)
    {
        GPBUtil::checkInt32($var);
        $this->requests = $var;

        return $this;
    }

    /**
     * Number of errors since this instance was started.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int32 errors = 10;</code>
     * @return int
     */
    public function getErrors()
    {
        return $this->errors;
    }

    /**
     * Number of errors since this instance was started.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int32 errors = 10;</code>
     * @param int $var
     * @return $this
     */
    public function setErrors($var)
    {
        GPBUtil::checkInt32($var);
        $this->errors = $var;

        return $this;
    }

    /**
     * Average queries per second (QPS) over the last minute.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>float qps = 11;</code>
     * @return float
     */
    public function getQps()
    {
        return $this->qps;
    }

    /**
     * Average queries per second (QPS) over the last minute.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>float qps = 11;</code>
     * @param float $var
     * @return $this
     */
    public function setQps($var)
    {
        GPBUtil::checkFloat($var);
        $this->qps = $var;

        return $this;
    }

    /**
     * Average latency (ms) over the last minute.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int32 average_latency = 12;</code>
     * @return int
     */
    public function getAverageLatency()
    {
        return $this->average_latency;
    }

    /**
     * Average latency (ms) over the last minute.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int32 average_latency = 12;</code>
     * @param int $var
     * @return $this
     */
    public function setAverageLatency($var)
    {
        GPBUtil::checkInt32($var);
        $this->average_latency = $var;

        return $this;
    }

    /**
     * Total memory in use (bytes).
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int64 memory_usage = 13;</code>
     * @return int|string
     */
    public function getMemoryUsage()
    {
        return $this->memory_usage;
    }

    /**
     * Total memory in use (bytes).
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>int64 memory_usage = 13;</code>
     * @param int|string $var
     * @return $this
     */
    public function setMemoryUsage($var)
    {
        GPBUtil::checkInt64($var);
        $this->memory_usage = $var;

        return $this;
    }

    /**
     * Status of the virtual machine where this instance lives. Only applicable
     * for instances in App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_status = 14;</code>
     * @return string
     */
    public function getVmStatus()
    {
        return $this->vm_status;
    }

    /**
     * Status of the virtual machine where this instance lives. Only applicable
     * for instances in App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>string vm_status = 14;</code>
     * @param string $var
     * @return $this
     */
    public function setVmStatus($var)
    {
        GPBUtil::checkString($var, True);
        $this->vm_status = $var;

        return $this;
    }

    /**
     * Whether this instance is in debug mode. Only applicable for instances in
     * App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>bool vm_debug_enabled = 15;</code>
     * @return bool
     */
    public function getVmDebugEnabled()
    {
        return $this->vm_debug_enabled;
    }

    /**
     * Whether this instance is in debug mode. Only applicable for instances in
     * App Engine flexible environment.
     * &#64;OutputOnly
     *
     * Generated from protobuf field <code>bool vm_debug_enabled = 15;</code>
     * @param bool $var
     * @return $this
     */
    public function setVmDebugEnabled($var)
    {
        GPBUtil::checkBool($var);
        $this->vm_debug_enabled = $var;

        return $this;
    }

}

