<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/bigtable/admin/cluster/v1/bigtable_cluster_data.proto

namespace Google\Bigtable\Admin\Cluster\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An isolated set of Cloud BigTable resources on which tables can be hosted.
 *
 * Generated from protobuf message <code>google.bigtable.admin.cluster.v1.Cluster</code>
 */
class Cluster extends \Google\Protobuf\Internal\Message
{
    /**
     * A permanent unique identifier for the cluster. For technical reasons, the
     * zone in which the cluster resides is included here.
     * Values are of the form
     * projects/<project>/zones/<zone>/clusters/[a-z][-a-z0-9]*
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    private $name = '';
    /**
     * The operation currently running on the cluster, if any.
     * This cannot be set directly, only through CreateCluster, UpdateCluster,
     * or UndeleteCluster. Calls to these methods will be rejected if
     * "current_operation" is already set.
     *
     * Generated from protobuf field <code>.google.longrunning.Operation current_operation = 3;</code>
     */
    private $current_operation = null;
    /**
     * The descriptive name for this cluster as it appears in UIs.
     * Must be unique per zone.
     *
     * Generated from protobuf field <code>string display_name = 4;</code>
     */
    private $display_name = '';
    /**
     * The number of serve nodes allocated to this cluster.
     *
     * Generated from protobuf field <code>int32 serve_nodes = 5;</code>
     */
    private $serve_nodes = 0;
    /**
     * What storage type to use for tables in this cluster. Only configurable at
     * cluster creation time. If unspecified, STORAGE_SSD will be used.
     *
     * Generated from protobuf field <code>.google.bigtable.admin.cluster.v1.StorageType default_storage_type = 8;</code>
     */
    private $default_storage_type = 0;

    public function __construct() {
        \GPBMetadata\Google\Bigtable\Admin\Cluster\V1\BigtableClusterData::initOnce();
        parent::__construct();
    }

    /**
     * A permanent unique identifier for the cluster. For technical reasons, the
     * zone in which the cluster resides is included here.
     * Values are of the form
     * projects/<project>/zones/<zone>/clusters/[a-z][-a-z0-9]*
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * A permanent unique identifier for the cluster. For technical reasons, the
     * zone in which the cluster resides is included here.
     * Values are of the form
     * projects/<project>/zones/<zone>/clusters/[a-z][-a-z0-9]*
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The operation currently running on the cluster, if any.
     * This cannot be set directly, only through CreateCluster, UpdateCluster,
     * or UndeleteCluster. Calls to these methods will be rejected if
     * "current_operation" is already set.
     *
     * Generated from protobuf field <code>.google.longrunning.Operation current_operation = 3;</code>
     * @return \Google\LongRunning\Operation
     */
    public function getCurrentOperation()
    {
        return $this->current_operation;
    }

    /**
     * The operation currently running on the cluster, if any.
     * This cannot be set directly, only through CreateCluster, UpdateCluster,
     * or UndeleteCluster. Calls to these methods will be rejected if
     * "current_operation" is already set.
     *
     * Generated from protobuf field <code>.google.longrunning.Operation current_operation = 3;</code>
     * @param \Google\LongRunning\Operation $var
     * @return $this
     */
    public function setCurrentOperation($var)
    {
        GPBUtil::checkMessage($var, \Google\LongRunning\Operation::class);
        $this->current_operation = $var;

        return $this;
    }

    /**
     * The descriptive name for this cluster as it appears in UIs.
     * Must be unique per zone.
     *
     * Generated from protobuf field <code>string display_name = 4;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * The descriptive name for this cluster as it appears in UIs.
     * Must be unique per zone.
     *
     * Generated from protobuf field <code>string display_name = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * The number of serve nodes allocated to this cluster.
     *
     * Generated from protobuf field <code>int32 serve_nodes = 5;</code>
     * @return int
     */
    public function getServeNodes()
    {
        return $this->serve_nodes;
    }

    /**
     * The number of serve nodes allocated to this cluster.
     *
     * Generated from protobuf field <code>int32 serve_nodes = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setServeNodes($var)
    {
        GPBUtil::checkInt32($var);
        $this->serve_nodes = $var;

        return $this;
    }

    /**
     * What storage type to use for tables in this cluster. Only configurable at
     * cluster creation time. If unspecified, STORAGE_SSD will be used.
     *
     * Generated from protobuf field <code>.google.bigtable.admin.cluster.v1.StorageType default_storage_type = 8;</code>
     * @return int
     */
    public function getDefaultStorageType()
    {
        return $this->default_storage_type;
    }

    /**
     * What storage type to use for tables in this cluster. Only configurable at
     * cluster creation time. If unspecified, STORAGE_SSD will be used.
     *
     * Generated from protobuf field <code>.google.bigtable.admin.cluster.v1.StorageType default_storage_type = 8;</code>
     * @param int $var
     * @return $this
     */
    public function setDefaultStorageType($var)
    {
        GPBUtil::checkEnum($var, \Google\Bigtable\Admin\Cluster\V1\StorageType::class);
        $this->default_storage_type = $var;

        return $this;
    }

}

