<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/functions/v1beta2/functions.proto

namespace Google\Cloud\Functions\V1beta2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Describes a Cloud Function that contains user computation executed in
 * response to an event. It encapsulate function and triggers configurations.
 *
 * Generated from protobuf message <code>google.cloud.functions.v1beta2.CloudFunction</code>
 */
class CloudFunction extends \Google\Protobuf\Internal\Message
{
    /**
     * A user-defined name of the function. Function names must be unique
     * globally and match pattern `projects/&#42;&#47;locations/&#42;&#47;functions/&#42;`
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    private $name = '';
    /**
     * Output only. Status of the function deployment.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v1beta2.CloudFunctionStatus status = 7;</code>
     */
    private $status = 0;
    /**
     * Output only. Name of the most recent operation modifying the function. If
     * the function status is `DEPLOYING` or `DELETING`, then it points to the
     * active operation.
     *
     * Generated from protobuf field <code>string latest_operation = 8;</code>
     */
    private $latest_operation = '';
    /**
     * The name of the function (as defined in source code) that will be
     * executed. Defaults to the resource name suffix, if not specified. For
     * backward compatibility, if function with given name is not found, then the
     * system will try to use function named "function".
     * For Node.js this is name of a function exported by the module specified
     * in `source_location`.
     *
     * Generated from protobuf field <code>string entry_point = 9;</code>
     */
    private $entry_point = '';
    /**
     * The function execution timeout. Execution is considered failed and
     * can be terminated if the function is not completed at the end of the
     * timeout period. Defaults to 60 seconds.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration timeout = 10;</code>
     */
    private $timeout = null;
    /**
     * The amount of memory in MB available for a function.
     * Defaults to 256MB.
     *
     * Generated from protobuf field <code>int32 available_memory_mb = 11;</code>
     */
    private $available_memory_mb = 0;
    /**
     * Output only. The service account of the function.
     *
     * Generated from protobuf field <code>string service_account = 13;</code>
     */
    private $service_account = '';
    /**
     * Output only. The last update timestamp of a Cloud Function.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 15;</code>
     */
    private $update_time = null;
    protected $source_code;
    protected $trigger;

    public function __construct() {
        \GPBMetadata\Google\Cloud\Functions\V1Beta2\Functions::initOnce();
        parent::__construct();
    }

    /**
     * A user-defined name of the function. Function names must be unique
     * globally and match pattern `projects/&#42;&#47;locations/&#42;&#47;functions/&#42;`
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * A user-defined name of the function. Function names must be unique
     * globally and match pattern `projects/&#42;&#47;locations/&#42;&#47;functions/&#42;`
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The URL, starting with gs://, pointing to the zip archive which contains
     * the function.
     *
     * Generated from protobuf field <code>string source_archive_url = 14;</code>
     * @return string
     */
    public function getSourceArchiveUrl()
    {
        return $this->readOneof(14);
    }

    /**
     * The URL, starting with gs://, pointing to the zip archive which contains
     * the function.
     *
     * Generated from protobuf field <code>string source_archive_url = 14;</code>
     * @param string $var
     * @return $this
     */
    public function setSourceArchiveUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(14, $var);

        return $this;
    }

    /**
     * The hosted repository where the function is defined.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v1beta2.SourceRepository source_repository = 3;</code>
     * @return \Google\Cloud\Functions\V1beta2\SourceRepository
     */
    public function getSourceRepository()
    {
        return $this->readOneof(3);
    }

    /**
     * The hosted repository where the function is defined.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v1beta2.SourceRepository source_repository = 3;</code>
     * @param \Google\Cloud\Functions\V1beta2\SourceRepository $var
     * @return $this
     */
    public function setSourceRepository($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Functions\V1beta2\SourceRepository::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * An HTTPS endpoint type of source that can be triggered via URL.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v1beta2.HTTPSTrigger https_trigger = 6;</code>
     * @return \Google\Cloud\Functions\V1beta2\HTTPSTrigger
     */
    public function getHttpsTrigger()
    {
        return $this->readOneof(6);
    }

    /**
     * An HTTPS endpoint type of source that can be triggered via URL.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v1beta2.HTTPSTrigger https_trigger = 6;</code>
     * @param \Google\Cloud\Functions\V1beta2\HTTPSTrigger $var
     * @return $this
     */
    public function setHttpsTrigger($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Functions\V1beta2\HTTPSTrigger::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * A source that fires events in response to a condition in another service.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v1beta2.EventTrigger event_trigger = 12;</code>
     * @return \Google\Cloud\Functions\V1beta2\EventTrigger
     */
    public function getEventTrigger()
    {
        return $this->readOneof(12);
    }

    /**
     * A source that fires events in response to a condition in another service.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v1beta2.EventTrigger event_trigger = 12;</code>
     * @param \Google\Cloud\Functions\V1beta2\EventTrigger $var
     * @return $this
     */
    public function setEventTrigger($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Functions\V1beta2\EventTrigger::class);
        $this->writeOneof(12, $var);

        return $this;
    }

    /**
     * Output only. Status of the function deployment.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v1beta2.CloudFunctionStatus status = 7;</code>
     * @return int
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Output only. Status of the function deployment.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v1beta2.CloudFunctionStatus status = 7;</code>
     * @param int $var
     * @return $this
     */
    public function setStatus($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Functions\V1beta2\CloudFunctionStatus::class);
        $this->status = $var;

        return $this;
    }

    /**
     * Output only. Name of the most recent operation modifying the function. If
     * the function status is `DEPLOYING` or `DELETING`, then it points to the
     * active operation.
     *
     * Generated from protobuf field <code>string latest_operation = 8;</code>
     * @return string
     */
    public function getLatestOperation()
    {
        return $this->latest_operation;
    }

    /**
     * Output only. Name of the most recent operation modifying the function. If
     * the function status is `DEPLOYING` or `DELETING`, then it points to the
     * active operation.
     *
     * Generated from protobuf field <code>string latest_operation = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setLatestOperation($var)
    {
        GPBUtil::checkString($var, True);
        $this->latest_operation = $var;

        return $this;
    }

    /**
     * The name of the function (as defined in source code) that will be
     * executed. Defaults to the resource name suffix, if not specified. For
     * backward compatibility, if function with given name is not found, then the
     * system will try to use function named "function".
     * For Node.js this is name of a function exported by the module specified
     * in `source_location`.
     *
     * Generated from protobuf field <code>string entry_point = 9;</code>
     * @return string
     */
    public function getEntryPoint()
    {
        return $this->entry_point;
    }

    /**
     * The name of the function (as defined in source code) that will be
     * executed. Defaults to the resource name suffix, if not specified. For
     * backward compatibility, if function with given name is not found, then the
     * system will try to use function named "function".
     * For Node.js this is name of a function exported by the module specified
     * in `source_location`.
     *
     * Generated from protobuf field <code>string entry_point = 9;</code>
     * @param string $var
     * @return $this
     */
    public function setEntryPoint($var)
    {
        GPBUtil::checkString($var, True);
        $this->entry_point = $var;

        return $this;
    }

    /**
     * The function execution timeout. Execution is considered failed and
     * can be terminated if the function is not completed at the end of the
     * timeout period. Defaults to 60 seconds.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration timeout = 10;</code>
     * @return \Google\Protobuf\Duration
     */
    public function getTimeout()
    {
        return $this->timeout;
    }

    /**
     * The function execution timeout. Execution is considered failed and
     * can be terminated if the function is not completed at the end of the
     * timeout period. Defaults to 60 seconds.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration timeout = 10;</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setTimeout($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->timeout = $var;

        return $this;
    }

    /**
     * The amount of memory in MB available for a function.
     * Defaults to 256MB.
     *
     * Generated from protobuf field <code>int32 available_memory_mb = 11;</code>
     * @return int
     */
    public function getAvailableMemoryMb()
    {
        return $this->available_memory_mb;
    }

    /**
     * The amount of memory in MB available for a function.
     * Defaults to 256MB.
     *
     * Generated from protobuf field <code>int32 available_memory_mb = 11;</code>
     * @param int $var
     * @return $this
     */
    public function setAvailableMemoryMb($var)
    {
        GPBUtil::checkInt32($var);
        $this->available_memory_mb = $var;

        return $this;
    }

    /**
     * Output only. The service account of the function.
     *
     * Generated from protobuf field <code>string service_account = 13;</code>
     * @return string
     */
    public function getServiceAccount()
    {
        return $this->service_account;
    }

    /**
     * Output only. The service account of the function.
     *
     * Generated from protobuf field <code>string service_account = 13;</code>
     * @param string $var
     * @return $this
     */
    public function setServiceAccount($var)
    {
        GPBUtil::checkString($var, True);
        $this->service_account = $var;

        return $this;
    }

    /**
     * Output only. The last update timestamp of a Cloud Function.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 15;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    /**
     * Output only. The last update timestamp of a Cloud Function.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 15;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getSourceCode()
    {
        return $this->whichOneof("source_code");
    }

    /**
     * @return string
     */
    public function getTrigger()
    {
        return $this->whichOneof("trigger");
    }

}

