<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/ml/v1/job_service.proto

namespace Google\Cloud\Ml\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents the result of a single hyperparameter tuning trial from a
 * training job. The TrainingOutput object that is returned on successful
 * completion of a training job with hyperparameter tuning includes a list
 * of HyperparameterOutput objects, one for each successful trial.
 *
 * Generated from protobuf message <code>google.cloud.ml.v1.HyperparameterOutput</code>
 */
class HyperparameterOutput extends \Google\Protobuf\Internal\Message
{
    /**
     * The trial id for these results.
     *
     * Generated from protobuf field <code>string trial_id = 1;</code>
     */
    private $trial_id = '';
    /**
     * The hyperparameters given to this trial.
     *
     * Generated from protobuf field <code>map<string, string> hyperparameters = 2;</code>
     */
    private $hyperparameters;
    /**
     * The final objective metric seen for this trial.
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1.HyperparameterOutput.HyperparameterMetric final_metric = 3;</code>
     */
    private $final_metric = null;
    /**
     * All recorded object metrics for this trial.
     *
     * Generated from protobuf field <code>repeated .google.cloud.ml.v1.HyperparameterOutput.HyperparameterMetric all_metrics = 4;</code>
     */
    private $all_metrics;

    public function __construct() {
        \GPBMetadata\Google\Cloud\Ml\V1\JobService::initOnce();
        parent::__construct();
    }

    /**
     * The trial id for these results.
     *
     * Generated from protobuf field <code>string trial_id = 1;</code>
     * @return string
     */
    public function getTrialId()
    {
        return $this->trial_id;
    }

    /**
     * The trial id for these results.
     *
     * Generated from protobuf field <code>string trial_id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setTrialId($var)
    {
        GPBUtil::checkString($var, True);
        $this->trial_id = $var;

        return $this;
    }

    /**
     * The hyperparameters given to this trial.
     *
     * Generated from protobuf field <code>map<string, string> hyperparameters = 2;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getHyperparameters()
    {
        return $this->hyperparameters;
    }

    /**
     * The hyperparameters given to this trial.
     *
     * Generated from protobuf field <code>map<string, string> hyperparameters = 2;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setHyperparameters($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->hyperparameters = $arr;

        return $this;
    }

    /**
     * The final objective metric seen for this trial.
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1.HyperparameterOutput.HyperparameterMetric final_metric = 3;</code>
     * @return \Google\Cloud\Ml\V1\HyperparameterOutput_HyperparameterMetric
     */
    public function getFinalMetric()
    {
        return $this->final_metric;
    }

    /**
     * The final objective metric seen for this trial.
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1.HyperparameterOutput.HyperparameterMetric final_metric = 3;</code>
     * @param \Google\Cloud\Ml\V1\HyperparameterOutput_HyperparameterMetric $var
     * @return $this
     */
    public function setFinalMetric($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Ml\V1\HyperparameterOutput_HyperparameterMetric::class);
        $this->final_metric = $var;

        return $this;
    }

    /**
     * All recorded object metrics for this trial.
     *
     * Generated from protobuf field <code>repeated .google.cloud.ml.v1.HyperparameterOutput.HyperparameterMetric all_metrics = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getAllMetrics()
    {
        return $this->all_metrics;
    }

    /**
     * All recorded object metrics for this trial.
     *
     * Generated from protobuf field <code>repeated .google.cloud.ml.v1.HyperparameterOutput.HyperparameterMetric all_metrics = 4;</code>
     * @param \Google\Cloud\Ml\V1\HyperparameterOutput_HyperparameterMetric[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setAllMetrics($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Ml\V1\HyperparameterOutput_HyperparameterMetric::class);
        $this->all_metrics = $arr;

        return $this;
    }

}

