<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/ml/v1/job_service.proto

namespace Google\Cloud\Ml\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a single hyperparameter to optimize.
 *
 * Generated from protobuf message <code>google.cloud.ml.v1.ParameterSpec</code>
 */
class ParameterSpec extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parameter name must be unique amongst all ParameterConfigs in
     * a HyperparameterSpec message. E.g., "learning_rate".
     *
     * Generated from protobuf field <code>string parameter_name = 1;</code>
     */
    private $parameter_name = '';
    /**
     * Required. The type of the parameter.
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1.ParameterSpec.ParameterType type = 4;</code>
     */
    private $type = 0;
    /**
     * Required if type is `DOUBLE` or `INTEGER`. This field
     * should be unset if type is `CATEGORICAL`. This value should be integers if
     * type is INTEGER.
     *
     * Generated from protobuf field <code>double min_value = 2;</code>
     */
    private $min_value = 0.0;
    /**
     * Required if typeis `DOUBLE` or `INTEGER`. This field
     * should be unset if type is `CATEGORICAL`. This value should be integers if
     * type is `INTEGER`.
     *
     * Generated from protobuf field <code>double max_value = 3;</code>
     */
    private $max_value = 0.0;
    /**
     * Required if type is `CATEGORICAL`. The list of possible categories.
     *
     * Generated from protobuf field <code>repeated string categorical_values = 5;</code>
     */
    private $categorical_values;
    /**
     * Required if type is `DISCRETE`.
     * A list of feasible points.
     * The list should be in strictly increasing order. For instance, this
     * parameter might have possible settings of 1.5, 2.5, and 4.0. This list
     * should not contain more than 1,000 values.
     *
     * Generated from protobuf field <code>repeated double discrete_values = 6;</code>
     */
    private $discrete_values;
    /**
     * Optional. How the parameter should be scaled to the hypercube.
     * Leave unset for categorical parameters.
     * Some kind of scaling is strongly recommended for real or integral
     * parameters (e.g., `UNIT_LINEAR_SCALE`).
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1.ParameterSpec.ScaleType scale_type = 7;</code>
     */
    private $scale_type = 0;

    public function __construct() {
        \GPBMetadata\Google\Cloud\Ml\V1\JobService::initOnce();
        parent::__construct();
    }

    /**
     * Required. The parameter name must be unique amongst all ParameterConfigs in
     * a HyperparameterSpec message. E.g., "learning_rate".
     *
     * Generated from protobuf field <code>string parameter_name = 1;</code>
     * @return string
     */
    public function getParameterName()
    {
        return $this->parameter_name;
    }

    /**
     * Required. The parameter name must be unique amongst all ParameterConfigs in
     * a HyperparameterSpec message. E.g., "learning_rate".
     *
     * Generated from protobuf field <code>string parameter_name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setParameterName($var)
    {
        GPBUtil::checkString($var, True);
        $this->parameter_name = $var;

        return $this;
    }

    /**
     * Required. The type of the parameter.
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1.ParameterSpec.ParameterType type = 4;</code>
     * @return int
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * Required. The type of the parameter.
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1.ParameterSpec.ParameterType type = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Ml\V1\ParameterSpec_ParameterType::class);
        $this->type = $var;

        return $this;
    }

    /**
     * Required if type is `DOUBLE` or `INTEGER`. This field
     * should be unset if type is `CATEGORICAL`. This value should be integers if
     * type is INTEGER.
     *
     * Generated from protobuf field <code>double min_value = 2;</code>
     * @return float
     */
    public function getMinValue()
    {
        return $this->min_value;
    }

    /**
     * Required if type is `DOUBLE` or `INTEGER`. This field
     * should be unset if type is `CATEGORICAL`. This value should be integers if
     * type is INTEGER.
     *
     * Generated from protobuf field <code>double min_value = 2;</code>
     * @param float $var
     * @return $this
     */
    public function setMinValue($var)
    {
        GPBUtil::checkDouble($var);
        $this->min_value = $var;

        return $this;
    }

    /**
     * Required if typeis `DOUBLE` or `INTEGER`. This field
     * should be unset if type is `CATEGORICAL`. This value should be integers if
     * type is `INTEGER`.
     *
     * Generated from protobuf field <code>double max_value = 3;</code>
     * @return float
     */
    public function getMaxValue()
    {
        return $this->max_value;
    }

    /**
     * Required if typeis `DOUBLE` or `INTEGER`. This field
     * should be unset if type is `CATEGORICAL`. This value should be integers if
     * type is `INTEGER`.
     *
     * Generated from protobuf field <code>double max_value = 3;</code>
     * @param float $var
     * @return $this
     */
    public function setMaxValue($var)
    {
        GPBUtil::checkDouble($var);
        $this->max_value = $var;

        return $this;
    }

    /**
     * Required if type is `CATEGORICAL`. The list of possible categories.
     *
     * Generated from protobuf field <code>repeated string categorical_values = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getCategoricalValues()
    {
        return $this->categorical_values;
    }

    /**
     * Required if type is `CATEGORICAL`. The list of possible categories.
     *
     * Generated from protobuf field <code>repeated string categorical_values = 5;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setCategoricalValues($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->categorical_values = $arr;

        return $this;
    }

    /**
     * Required if type is `DISCRETE`.
     * A list of feasible points.
     * The list should be in strictly increasing order. For instance, this
     * parameter might have possible settings of 1.5, 2.5, and 4.0. This list
     * should not contain more than 1,000 values.
     *
     * Generated from protobuf field <code>repeated double discrete_values = 6;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getDiscreteValues()
    {
        return $this->discrete_values;
    }

    /**
     * Required if type is `DISCRETE`.
     * A list of feasible points.
     * The list should be in strictly increasing order. For instance, this
     * parameter might have possible settings of 1.5, 2.5, and 4.0. This list
     * should not contain more than 1,000 values.
     *
     * Generated from protobuf field <code>repeated double discrete_values = 6;</code>
     * @param float[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setDiscreteValues($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::DOUBLE);
        $this->discrete_values = $arr;

        return $this;
    }

    /**
     * Optional. How the parameter should be scaled to the hypercube.
     * Leave unset for categorical parameters.
     * Some kind of scaling is strongly recommended for real or integral
     * parameters (e.g., `UNIT_LINEAR_SCALE`).
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1.ParameterSpec.ScaleType scale_type = 7;</code>
     * @return int
     */
    public function getScaleType()
    {
        return $this->scale_type;
    }

    /**
     * Optional. How the parameter should be scaled to the hypercube.
     * Leave unset for categorical parameters.
     * Some kind of scaling is strongly recommended for real or integral
     * parameters (e.g., `UNIT_LINEAR_SCALE`).
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1.ParameterSpec.ScaleType scale_type = 7;</code>
     * @param int $var
     * @return $this
     */
    public function setScaleType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Ml\V1\ParameterSpec_ScaleType::class);
        $this->scale_type = $var;

        return $this;
    }

}

