<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/ml/v1beta1/job_service.proto

namespace Google\Cloud\Ml\V1beta1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents input parameters for a prediction job.
 *
 * Generated from protobuf message <code>google.cloud.ml.v1beta1.PredictionInput</code>
 */
class PredictionInput extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The format of the input data files.
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1beta1.PredictionInput.DataFormat data_format = 3;</code>
     */
    private $data_format = 0;
    /**
     * Required. The Google Cloud Storage location of the input data files.
     * May contain wildcards.
     *
     * Generated from protobuf field <code>repeated string input_paths = 4;</code>
     */
    private $input_paths;
    /**
     * Required. The output Google Cloud Storage location.
     *
     * Generated from protobuf field <code>string output_path = 5;</code>
     */
    private $output_path = '';
    /**
     * Optional. The maximum number of workers to be used for parallel processing.
     * Defaults to 10 if not specified.
     *
     * Generated from protobuf field <code>int64 max_worker_count = 6;</code>
     */
    private $max_worker_count = 0;
    /**
     * Required. The Google Compute Engine region to run the prediction job in.
     *
     * Generated from protobuf field <code>string region = 7;</code>
     */
    private $region = '';
    /**
     * Optional. The Google Cloud ML runtime version to use for this batch
     * prediction. If not set, Google Cloud ML will pick the runtime version used
     * during the CreateVersion request for this model version, or choose the
     * latest stable version when model version information is not available
     * such as when the model is specified by uri.
     *
     * Generated from protobuf field <code>string runtime_version = 8;</code>
     */
    private $runtime_version = '';
    protected $model_version;

    public function __construct() {
        \GPBMetadata\Google\Cloud\Ml\V1Beta1\JobService::initOnce();
        parent::__construct();
    }

    /**
     * Use this field if you want to use the default version for the specified
     * model. The string must use the following format:
     * `"projects/<var>[YOUR_PROJECT]</var>/models/<var>[YOUR_MODEL]</var>"`
     *
     * Generated from protobuf field <code>string model_name = 1;</code>
     * @return string
     */
    public function getModelName()
    {
        return $this->readOneof(1);
    }

    /**
     * Use this field if you want to use the default version for the specified
     * model. The string must use the following format:
     * `"projects/<var>[YOUR_PROJECT]</var>/models/<var>[YOUR_MODEL]</var>"`
     *
     * Generated from protobuf field <code>string model_name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setModelName($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     * Use this field if you want to specify a version of the model to use. The
     * string is formatted the same way as `model_version`, with the addition
     * of the version information:
     * `"projects/<var>[YOUR_PROJECT]</var>/models/<var>YOUR_MODEL/versions/<var>[YOUR_VERSION]</var>"`
     *
     * Generated from protobuf field <code>string version_name = 2;</code>
     * @return string
     */
    public function getVersionName()
    {
        return $this->readOneof(2);
    }

    /**
     * Use this field if you want to specify a version of the model to use. The
     * string is formatted the same way as `model_version`, with the addition
     * of the version information:
     * `"projects/<var>[YOUR_PROJECT]</var>/models/<var>YOUR_MODEL/versions/<var>[YOUR_VERSION]</var>"`
     *
     * Generated from protobuf field <code>string version_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setVersionName($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * Use this field if you want to specify a Google Cloud Storage path for
     * the model to use.
     *
     * Generated from protobuf field <code>string uri = 9;</code>
     * @return string
     */
    public function getUri()
    {
        return $this->readOneof(9);
    }

    /**
     * Use this field if you want to specify a Google Cloud Storage path for
     * the model to use.
     *
     * Generated from protobuf field <code>string uri = 9;</code>
     * @param string $var
     * @return $this
     */
    public function setUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(9, $var);

        return $this;
    }

    /**
     * Required. The format of the input data files.
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1beta1.PredictionInput.DataFormat data_format = 3;</code>
     * @return int
     */
    public function getDataFormat()
    {
        return $this->data_format;
    }

    /**
     * Required. The format of the input data files.
     *
     * Generated from protobuf field <code>.google.cloud.ml.v1beta1.PredictionInput.DataFormat data_format = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setDataFormat($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Ml\V1beta1\PredictionInput_DataFormat::class);
        $this->data_format = $var;

        return $this;
    }

    /**
     * Required. The Google Cloud Storage location of the input data files.
     * May contain wildcards.
     *
     * Generated from protobuf field <code>repeated string input_paths = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getInputPaths()
    {
        return $this->input_paths;
    }

    /**
     * Required. The Google Cloud Storage location of the input data files.
     * May contain wildcards.
     *
     * Generated from protobuf field <code>repeated string input_paths = 4;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setInputPaths($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->input_paths = $arr;

        return $this;
    }

    /**
     * Required. The output Google Cloud Storage location.
     *
     * Generated from protobuf field <code>string output_path = 5;</code>
     * @return string
     */
    public function getOutputPath()
    {
        return $this->output_path;
    }

    /**
     * Required. The output Google Cloud Storage location.
     *
     * Generated from protobuf field <code>string output_path = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setOutputPath($var)
    {
        GPBUtil::checkString($var, True);
        $this->output_path = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of workers to be used for parallel processing.
     * Defaults to 10 if not specified.
     *
     * Generated from protobuf field <code>int64 max_worker_count = 6;</code>
     * @return int|string
     */
    public function getMaxWorkerCount()
    {
        return $this->max_worker_count;
    }

    /**
     * Optional. The maximum number of workers to be used for parallel processing.
     * Defaults to 10 if not specified.
     *
     * Generated from protobuf field <code>int64 max_worker_count = 6;</code>
     * @param int|string $var
     * @return $this
     */
    public function setMaxWorkerCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->max_worker_count = $var;

        return $this;
    }

    /**
     * Required. The Google Compute Engine region to run the prediction job in.
     *
     * Generated from protobuf field <code>string region = 7;</code>
     * @return string
     */
    public function getRegion()
    {
        return $this->region;
    }

    /**
     * Required. The Google Compute Engine region to run the prediction job in.
     *
     * Generated from protobuf field <code>string region = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setRegion($var)
    {
        GPBUtil::checkString($var, True);
        $this->region = $var;

        return $this;
    }

    /**
     * Optional. The Google Cloud ML runtime version to use for this batch
     * prediction. If not set, Google Cloud ML will pick the runtime version used
     * during the CreateVersion request for this model version, or choose the
     * latest stable version when model version information is not available
     * such as when the model is specified by uri.
     *
     * Generated from protobuf field <code>string runtime_version = 8;</code>
     * @return string
     */
    public function getRuntimeVersion()
    {
        return $this->runtime_version;
    }

    /**
     * Optional. The Google Cloud ML runtime version to use for this batch
     * prediction. If not set, Google Cloud ML will pick the runtime version used
     * during the CreateVersion request for this model version, or choose the
     * latest stable version when model version information is not available
     * such as when the model is specified by uri.
     *
     * Generated from protobuf field <code>string runtime_version = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setRuntimeVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->runtime_version = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getModelVersion()
    {
        return $this->whichOneof("model_version");
    }

}

