<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/resourcemanager/v2/folders.proto

namespace Google\Cloud\ResourceManager\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A Folder in an Organization's resource hierarchy, used to
 * organize that Organization's resources.
 *
 * Generated from protobuf message <code>google.cloud.resourcemanager.v2.Folder</code>
 */
class Folder extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The resource name of the Folder.
     * Its format is `folders/{folder_id}`, for example: "folders/1234".
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    private $name = '';
    /**
     * The Folder’s parent's resource name.
     * Updates to the folder's parent must be performed via [MoveFolders].
     *
     * Generated from protobuf field <code>string parent = 2;</code>
     */
    private $parent = '';
    /**
     * The folder’s display name.
     * A folder’s display name must be unique amongst its siblings, e.g.
     * no two folders with the same parent can share the same display name.
     * The display name must start and end with a letter or digit, may contain
     * letters, digits, spaces, hyphens and underscores and can be no longer
     * than 30 characters. This is captured by the regular expression:
     * [\p{L}\p{N}]({\p{L}\p{N}_- ]{0,28}[\p{L}\p{N}])?.
     *
     * Generated from protobuf field <code>string display_name = 3;</code>
     */
    private $display_name = '';
    /**
     * Output only.  The lifecycle state of the folder.
     * Updates to the lifecycle_state must be performed via
     * [DeleteFolder] and [UndeleteFolder].
     *
     * Generated from protobuf field <code>.google.cloud.resourcemanager.v2.Folder.LifecycleState lifecycle_state = 4;</code>
     */
    private $lifecycle_state = 0;
    /**
     * Output only. Timestamp when the Folder was created. Assigned by the server.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5;</code>
     */
    private $create_time = null;
    /**
     * Output only. Timestamp when the Folder was last modified.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6;</code>
     */
    private $update_time = null;

    public function __construct() {
        \GPBMetadata\Google\Cloud\Resourcemanager\V2\Folders::initOnce();
        parent::__construct();
    }

    /**
     * Output only. The resource name of the Folder.
     * Its format is `folders/{folder_id}`, for example: "folders/1234".
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The resource name of the Folder.
     * Its format is `folders/{folder_id}`, for example: "folders/1234".
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The Folder’s parent's resource name.
     * Updates to the folder's parent must be performed via [MoveFolders].
     *
     * Generated from protobuf field <code>string parent = 2;</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * The Folder’s parent's resource name.
     * Updates to the folder's parent must be performed via [MoveFolders].
     *
     * Generated from protobuf field <code>string parent = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The folder’s display name.
     * A folder’s display name must be unique amongst its siblings, e.g.
     * no two folders with the same parent can share the same display name.
     * The display name must start and end with a letter or digit, may contain
     * letters, digits, spaces, hyphens and underscores and can be no longer
     * than 30 characters. This is captured by the regular expression:
     * [\p{L}\p{N}]({\p{L}\p{N}_- ]{0,28}[\p{L}\p{N}])?.
     *
     * Generated from protobuf field <code>string display_name = 3;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * The folder’s display name.
     * A folder’s display name must be unique amongst its siblings, e.g.
     * no two folders with the same parent can share the same display name.
     * The display name must start and end with a letter or digit, may contain
     * letters, digits, spaces, hyphens and underscores and can be no longer
     * than 30 characters. This is captured by the regular expression:
     * [\p{L}\p{N}]({\p{L}\p{N}_- ]{0,28}[\p{L}\p{N}])?.
     *
     * Generated from protobuf field <code>string display_name = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Output only.  The lifecycle state of the folder.
     * Updates to the lifecycle_state must be performed via
     * [DeleteFolder] and [UndeleteFolder].
     *
     * Generated from protobuf field <code>.google.cloud.resourcemanager.v2.Folder.LifecycleState lifecycle_state = 4;</code>
     * @return int
     */
    public function getLifecycleState()
    {
        return $this->lifecycle_state;
    }

    /**
     * Output only.  The lifecycle state of the folder.
     * Updates to the lifecycle_state must be performed via
     * [DeleteFolder] and [UndeleteFolder].
     *
     * Generated from protobuf field <code>.google.cloud.resourcemanager.v2.Folder.LifecycleState lifecycle_state = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setLifecycleState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\ResourceManager\V2\Folder_LifecycleState::class);
        $this->lifecycle_state = $var;

        return $this;
    }

    /**
     * Output only. Timestamp when the Folder was created. Assigned by the server.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    /**
     * Output only. Timestamp when the Folder was created. Assigned by the server.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Timestamp when the Folder was last modified.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    /**
     * Output only. Timestamp when the Folder was last modified.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

}

