<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/resourcemanager/v2/folders.proto

namespace Google\Cloud\ResourceManager\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The ListFolders request message.
 *
 * Generated from protobuf message <code>google.cloud.resourcemanager.v2.ListFoldersRequest</code>
 */
class ListFoldersRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * The resource name of the Organization or Folder whose Folders are
     * being listed.
     * Must be of the form `folders/{folder_id}` or `organizations/{org_id}`.
     * Access to this method is controlled by checking the
     * `resourcemanager.folders.list` permission on the `parent`.
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     */
    private $parent = '';
    /**
     * The maximum number of Folders to return in the response.
     * This field is optional.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    private $page_size = 0;
    /**
     * A pagination token returned from a previous call to `ListFolders`
     * that indicates where this listing should continue from.
     * This field is optional.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    private $page_token = '';
    /**
     * Controls whether Folders in the [DELETE_REQUESTED} state should
     * be returned.
     *
     * Generated from protobuf field <code>bool show_deleted = 4;</code>
     */
    private $show_deleted = false;

    public function __construct() {
        \GPBMetadata\Google\Cloud\Resourcemanager\V2\Folders::initOnce();
        parent::__construct();
    }

    /**
     * The resource name of the Organization or Folder whose Folders are
     * being listed.
     * Must be of the form `folders/{folder_id}` or `organizations/{org_id}`.
     * Access to this method is controlled by checking the
     * `resourcemanager.folders.list` permission on the `parent`.
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * The resource name of the Organization or Folder whose Folders are
     * being listed.
     * Must be of the form `folders/{folder_id}` or `organizations/{org_id}`.
     * Access to this method is controlled by checking the
     * `resourcemanager.folders.list` permission on the `parent`.
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The maximum number of Folders to return in the response.
     * This field is optional.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of Folders to return in the response.
     * This field is optional.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A pagination token returned from a previous call to `ListFolders`
     * that indicates where this listing should continue from.
     * This field is optional.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A pagination token returned from a previous call to `ListFolders`
     * that indicates where this listing should continue from.
     * This field is optional.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Controls whether Folders in the [DELETE_REQUESTED} state should
     * be returned.
     *
     * Generated from protobuf field <code>bool show_deleted = 4;</code>
     * @return bool
     */
    public function getShowDeleted()
    {
        return $this->show_deleted;
    }

    /**
     * Controls whether Folders in the [DELETE_REQUESTED} state should
     * be returned.
     *
     * Generated from protobuf field <code>bool show_deleted = 4;</code>
     * @param bool $var
     * @return $this
     */
    public function setShowDeleted($var)
    {
        GPBUtil::checkBool($var);
        $this->show_deleted = $var;

        return $this;
    }

}

