<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/resourcemanager/v2/folders.proto

namespace Google\Cloud\ResourceManager\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for searching folders.
 *
 * Generated from protobuf message <code>google.cloud.resourcemanager.v2.SearchFoldersRequest</code>
 */
class SearchFoldersRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * The maximum number of folders to return in the response.
     * This field is optional.
     *
     * Generated from protobuf field <code>int32 page_size = 1;</code>
     */
    private $page_size = 0;
    /**
     * A pagination token returned from a previous call to `SearchFolders`
     * that indicates from where search should continue.
     * This field is optional.
     *
     * Generated from protobuf field <code>string page_token = 2;</code>
     */
    private $page_token = '';
    /**
     * Search criteria used to select the Folders to return.
     * If no search criteria is specified then all accessible folders will be
     * returned.
     * Query expressions can be used to restrict results based upon displayName,
     * lifecycleState and parent, where the operators `=`, `NOT`, `AND` and `OR`
     * can be used along with the suffix wildcard symbol `*`.
     * Some example queries are:
     * |Query|Description|
     * |------|-----------|
     * |displayName=Test*|Folders whose display name starts with "Test".|
     * |lifecycleState=ACTIVE|Folders whose lifecycleState is ACTIVE.|
     * |parent=folders/123|Folders whose parent is "folders/123".|
     * |parent=folders/123 AND lifecycleState=ACTIVE|Active folders whose
     * parent is "folders/123".|
     *
     * Generated from protobuf field <code>string query = 3;</code>
     */
    private $query = '';

    public function __construct() {
        \GPBMetadata\Google\Cloud\Resourcemanager\V2\Folders::initOnce();
        parent::__construct();
    }

    /**
     * The maximum number of folders to return in the response.
     * This field is optional.
     *
     * Generated from protobuf field <code>int32 page_size = 1;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of folders to return in the response.
     * This field is optional.
     *
     * Generated from protobuf field <code>int32 page_size = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A pagination token returned from a previous call to `SearchFolders`
     * that indicates from where search should continue.
     * This field is optional.
     *
     * Generated from protobuf field <code>string page_token = 2;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A pagination token returned from a previous call to `SearchFolders`
     * that indicates from where search should continue.
     * This field is optional.
     *
     * Generated from protobuf field <code>string page_token = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Search criteria used to select the Folders to return.
     * If no search criteria is specified then all accessible folders will be
     * returned.
     * Query expressions can be used to restrict results based upon displayName,
     * lifecycleState and parent, where the operators `=`, `NOT`, `AND` and `OR`
     * can be used along with the suffix wildcard symbol `*`.
     * Some example queries are:
     * |Query|Description|
     * |------|-----------|
     * |displayName=Test*|Folders whose display name starts with "Test".|
     * |lifecycleState=ACTIVE|Folders whose lifecycleState is ACTIVE.|
     * |parent=folders/123|Folders whose parent is "folders/123".|
     * |parent=folders/123 AND lifecycleState=ACTIVE|Active folders whose
     * parent is "folders/123".|
     *
     * Generated from protobuf field <code>string query = 3;</code>
     * @return string
     */
    public function getQuery()
    {
        return $this->query;
    }

    /**
     * Search criteria used to select the Folders to return.
     * If no search criteria is specified then all accessible folders will be
     * returned.
     * Query expressions can be used to restrict results based upon displayName,
     * lifecycleState and parent, where the operators `=`, `NOT`, `AND` and `OR`
     * can be used along with the suffix wildcard symbol `*`.
     * Some example queries are:
     * |Query|Description|
     * |------|-----------|
     * |displayName=Test*|Folders whose display name starts with "Test".|
     * |lifecycleState=ACTIVE|Folders whose lifecycleState is ACTIVE.|
     * |parent=folders/123|Folders whose parent is "folders/123".|
     * |parent=folders/123 AND lifecycleState=ACTIVE|Active folders whose
     * parent is "folders/123".|
     *
     * Generated from protobuf field <code>string query = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setQuery($var)
    {
        GPBUtil::checkString($var, True);
        $this->query = $var;

        return $this;
    }

}

