<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/runtimeconfig/v1beta1/runtimeconfig.proto

namespace Google\Cloud\RuntimeConfig\V1beta1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for the `ListVariables()` method.
 *
 * Generated from protobuf message <code>google.cloud.runtimeconfig.v1beta1.ListVariablesRequest</code>
 */
class ListVariablesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * The path to the RuntimeConfig resource for which you want to list variables.
     * The configuration must exist beforehand; the path must by in the format:
     * `projects/[PROJECT_ID]/configs/[CONFIG_NAME]`
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     */
    private $parent = '';
    /**
     * Filters variables by matching the specified filter. For example:
     * `projects/example-project/config/[CONFIG_NAME]/variables/example-variable`.
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     */
    private $filter = '';
    /**
     * Specifies the number of results to return per page. If there are fewer
     * elements than the specified number, returns all elements.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    private $page_size = 0;
    /**
     * Specifies a page token to use. Set `pageToken` to a `nextPageToken`
     * returned by a previous list request to get the next page of results.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    private $page_token = '';
    /**
     * The flag indicates whether the user wants to return values of variables.
     * If true, then only those variables that user has IAM GetVariable permission
     * will be returned along with their values.
     *
     * Generated from protobuf field <code>bool return_values = 5;</code>
     */
    private $return_values = false;

    public function __construct() {
        \GPBMetadata\Google\Cloud\Runtimeconfig\V1Beta1\Runtimeconfig::initOnce();
        parent::__construct();
    }

    /**
     * The path to the RuntimeConfig resource for which you want to list variables.
     * The configuration must exist beforehand; the path must by in the format:
     * `projects/[PROJECT_ID]/configs/[CONFIG_NAME]`
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * The path to the RuntimeConfig resource for which you want to list variables.
     * The configuration must exist beforehand; the path must by in the format:
     * `projects/[PROJECT_ID]/configs/[CONFIG_NAME]`
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Filters variables by matching the specified filter. For example:
     * `projects/example-project/config/[CONFIG_NAME]/variables/example-variable`.
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Filters variables by matching the specified filter. For example:
     * `projects/example-project/config/[CONFIG_NAME]/variables/example-variable`.
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Specifies the number of results to return per page. If there are fewer
     * elements than the specified number, returns all elements.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Specifies the number of results to return per page. If there are fewer
     * elements than the specified number, returns all elements.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Specifies a page token to use. Set `pageToken` to a `nextPageToken`
     * returned by a previous list request to get the next page of results.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Specifies a page token to use. Set `pageToken` to a `nextPageToken`
     * returned by a previous list request to get the next page of results.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * The flag indicates whether the user wants to return values of variables.
     * If true, then only those variables that user has IAM GetVariable permission
     * will be returned along with their values.
     *
     * Generated from protobuf field <code>bool return_values = 5;</code>
     * @return bool
     */
    public function getReturnValues()
    {
        return $this->return_values;
    }

    /**
     * The flag indicates whether the user wants to return values of variables.
     * If true, then only those variables that user has IAM GetVariable permission
     * will be returned along with their values.
     *
     * Generated from protobuf field <code>bool return_values = 5;</code>
     * @param bool $var
     * @return $this
     */
    public function setReturnValues($var)
    {
        GPBUtil::checkBool($var);
        $this->return_values = $var;

        return $this;
    }

}

