<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/support/common.proto

namespace Google\Cloud\Support\Common;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A support case created by the user.
 *
 * Generated from protobuf message <code>google.cloud.support.common.Case</code>
 */
class PBCase extends \Google\Protobuf\Internal\Message
{
    /**
     * The resource name for the Case in format
     * `supportAccounts/{account_id}/cases/{case_id}`
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    private $name = '';
    /**
     * The short summary of the issue reported in this case.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     */
    private $display_name = '';
    /**
     * The board description of issue provided with initial summary.
     *
     * Generated from protobuf field <code>string description = 3;</code>
     */
    private $description = '';
    /**
     * The product component for which this Case is reported.
     *
     * Generated from protobuf field <code>string component = 4;</code>
     */
    private $component = '';
    /**
     * The product subcomponent for which this Case is reported.
     *
     * Generated from protobuf field <code>string subcomponent = 5;</code>
     */
    private $subcomponent = '';
    /**
     * Timezone the client sending this request is in.
     * It should be in a format IANA recognizes: https://www.iana.org/time-zone
     * There is no additional validation done by the API.
     *
     * Generated from protobuf field <code>string client_timezone = 6;</code>
     */
    private $client_timezone = '';
    /**
     * The email addresses that can be copied to receive updates on this case.
     * Users can specify a maximum of 10 email addresses.
     *
     * Generated from protobuf field <code>repeated string cc_addresses = 7;</code>
     */
    private $cc_addresses;
    /**
     * The Google Cloud Platform project ID for which this case is created.
     *
     * Generated from protobuf field <code>string project_id = 8;</code>
     */
    private $project_id = '';
    /**
     * List of customer issues associated with this case.
     *
     * Generated from protobuf field <code>repeated .google.cloud.support.common.CustomerIssue issues = 10;</code>
     */
    private $issues;
    /**
     * The current priority of this case.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.Case.Priority priority = 11;</code>
     */
    private $priority = 0;
    /**
     * The current state of this case.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.Case.State state = 12;</code>
     */
    private $state = 0;
    /**
     * Time when this case was created.
     * Output only.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 13;</code>
     */
    private $create_time = null;
    /**
     * Time when this case was last updated.
     * Output only.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 14;</code>
     */
    private $update_time = null;
    /**
     * Email address of user who created this case.
     * Output only. It is inferred from credentials supplied during case creation.
     *
     * Generated from protobuf field <code>string creator_email = 15;</code>
     */
    private $creator_email = '';
    /**
     * The issue category applicable to this case.
     *
     * Generated from protobuf field <code>string category = 16;</code>
     */
    private $category = '';

    public function __construct() {
        \GPBMetadata\Google\Cloud\Support\Common::initOnce();
        parent::__construct();
    }

    /**
     * The resource name for the Case in format
     * `supportAccounts/{account_id}/cases/{case_id}`
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The resource name for the Case in format
     * `supportAccounts/{account_id}/cases/{case_id}`
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The short summary of the issue reported in this case.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * The short summary of the issue reported in this case.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * The board description of issue provided with initial summary.
     *
     * Generated from protobuf field <code>string description = 3;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * The board description of issue provided with initial summary.
     *
     * Generated from protobuf field <code>string description = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * The product component for which this Case is reported.
     *
     * Generated from protobuf field <code>string component = 4;</code>
     * @return string
     */
    public function getComponent()
    {
        return $this->component;
    }

    /**
     * The product component for which this Case is reported.
     *
     * Generated from protobuf field <code>string component = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setComponent($var)
    {
        GPBUtil::checkString($var, True);
        $this->component = $var;

        return $this;
    }

    /**
     * The product subcomponent for which this Case is reported.
     *
     * Generated from protobuf field <code>string subcomponent = 5;</code>
     * @return string
     */
    public function getSubcomponent()
    {
        return $this->subcomponent;
    }

    /**
     * The product subcomponent for which this Case is reported.
     *
     * Generated from protobuf field <code>string subcomponent = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setSubcomponent($var)
    {
        GPBUtil::checkString($var, True);
        $this->subcomponent = $var;

        return $this;
    }

    /**
     * Timezone the client sending this request is in.
     * It should be in a format IANA recognizes: https://www.iana.org/time-zone
     * There is no additional validation done by the API.
     *
     * Generated from protobuf field <code>string client_timezone = 6;</code>
     * @return string
     */
    public function getClientTimezone()
    {
        return $this->client_timezone;
    }

    /**
     * Timezone the client sending this request is in.
     * It should be in a format IANA recognizes: https://www.iana.org/time-zone
     * There is no additional validation done by the API.
     *
     * Generated from protobuf field <code>string client_timezone = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setClientTimezone($var)
    {
        GPBUtil::checkString($var, True);
        $this->client_timezone = $var;

        return $this;
    }

    /**
     * The email addresses that can be copied to receive updates on this case.
     * Users can specify a maximum of 10 email addresses.
     *
     * Generated from protobuf field <code>repeated string cc_addresses = 7;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getCcAddresses()
    {
        return $this->cc_addresses;
    }

    /**
     * The email addresses that can be copied to receive updates on this case.
     * Users can specify a maximum of 10 email addresses.
     *
     * Generated from protobuf field <code>repeated string cc_addresses = 7;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setCcAddresses($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->cc_addresses = $arr;

        return $this;
    }

    /**
     * The Google Cloud Platform project ID for which this case is created.
     *
     * Generated from protobuf field <code>string project_id = 8;</code>
     * @return string
     */
    public function getProjectId()
    {
        return $this->project_id;
    }

    /**
     * The Google Cloud Platform project ID for which this case is created.
     *
     * Generated from protobuf field <code>string project_id = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->project_id = $var;

        return $this;
    }

    /**
     * List of customer issues associated with this case.
     *
     * Generated from protobuf field <code>repeated .google.cloud.support.common.CustomerIssue issues = 10;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getIssues()
    {
        return $this->issues;
    }

    /**
     * List of customer issues associated with this case.
     *
     * Generated from protobuf field <code>repeated .google.cloud.support.common.CustomerIssue issues = 10;</code>
     * @param \Google\Cloud\Support\Common\CustomerIssue[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setIssues($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Support\Common\CustomerIssue::class);
        $this->issues = $arr;

        return $this;
    }

    /**
     * The current priority of this case.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.Case.Priority priority = 11;</code>
     * @return int
     */
    public function getPriority()
    {
        return $this->priority;
    }

    /**
     * The current priority of this case.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.Case.Priority priority = 11;</code>
     * @param int $var
     * @return $this
     */
    public function setPriority($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Support\Common\Case_Priority::class);
        $this->priority = $var;

        return $this;
    }

    /**
     * The current state of this case.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.Case.State state = 12;</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * The current state of this case.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.Case.State state = 12;</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Support\Common\Case_State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Time when this case was created.
     * Output only.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 13;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    /**
     * Time when this case was created.
     * Output only.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 13;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Time when this case was last updated.
     * Output only.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 14;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    /**
     * Time when this case was last updated.
     * Output only.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 14;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Email address of user who created this case.
     * Output only. It is inferred from credentials supplied during case creation.
     *
     * Generated from protobuf field <code>string creator_email = 15;</code>
     * @return string
     */
    public function getCreatorEmail()
    {
        return $this->creator_email;
    }

    /**
     * Email address of user who created this case.
     * Output only. It is inferred from credentials supplied during case creation.
     *
     * Generated from protobuf field <code>string creator_email = 15;</code>
     * @param string $var
     * @return $this
     */
    public function setCreatorEmail($var)
    {
        GPBUtil::checkString($var, True);
        $this->creator_email = $var;

        return $this;
    }

    /**
     * The issue category applicable to this case.
     *
     * Generated from protobuf field <code>string category = 16;</code>
     * @return string
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * The issue category applicable to this case.
     *
     * Generated from protobuf field <code>string category = 16;</code>
     * @param string $var
     * @return $this
     */
    public function setCategory($var)
    {
        GPBUtil::checkString($var, True);
        $this->category = $var;

        return $this;
    }

}

