<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/support/common.proto

namespace Google\Cloud\Support\Common;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A Google Cloud Platform account that identifies support eligibility for a
 * Cloud resource. Currently the Cloud resource can only be an Organization
 * but this might change in future.
 *
 * Generated from protobuf message <code>google.cloud.support.common.SupportAccount</code>
 */
class SupportAccount extends \Google\Protobuf\Internal\Message
{
    /**
     * The resource name for a support account in format
     * `supportAccounts/{account_id}`.
     * Output only.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    private $name = '';
    /**
     * Identifier for this entity that gets persisted in storage system. The
     * resource name is populated using this field in format
     * `supportAccounts/{account_id}`.
     *
     * Generated from protobuf field <code>string account_id = 2;</code>
     */
    private $account_id = '';
    /**
     * The Cloud resource with which this support account is associated.
     *
     * Generated from protobuf field <code>string cloud_resource = 3;</code>
     */
    private $cloud_resource = '';
    /**
     * A user friendly display name assigned to this support account.
     *
     * Generated from protobuf field <code>string display_name = 4;</code>
     */
    private $display_name = '';
    /**
     * Indicates the current state of an account.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.SupportAccount.State state = 5;</code>
     */
    private $state = 0;
    /**
     * Time when this account was created.
     * Output only.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 6;</code>
     */
    private $create_time = null;
    /**
     * The resource name of a billing account associated with this support
     * account. For example, `billingAccounts/ABCDEF-012345-567890`.
     *
     * Generated from protobuf field <code>string billing_account_name = 7;</code>
     */
    private $billing_account_name = '';
    /**
     * Generated from protobuf field <code>string unify_account_id = 8;</code>
     */
    private $unify_account_id = '';
    /**
     * The PricingModel applicable to this support account.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.SupportAccount.PricingModel pricing_model = 9;</code>
     */
    private $pricing_model = 0;

    public function __construct() {
        \GPBMetadata\Google\Cloud\Support\Common::initOnce();
        parent::__construct();
    }

    /**
     * The resource name for a support account in format
     * `supportAccounts/{account_id}`.
     * Output only.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The resource name for a support account in format
     * `supportAccounts/{account_id}`.
     * Output only.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Identifier for this entity that gets persisted in storage system. The
     * resource name is populated using this field in format
     * `supportAccounts/{account_id}`.
     *
     * Generated from protobuf field <code>string account_id = 2;</code>
     * @return string
     */
    public function getAccountId()
    {
        return $this->account_id;
    }

    /**
     * Identifier for this entity that gets persisted in storage system. The
     * resource name is populated using this field in format
     * `supportAccounts/{account_id}`.
     *
     * Generated from protobuf field <code>string account_id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setAccountId($var)
    {
        GPBUtil::checkString($var, True);
        $this->account_id = $var;

        return $this;
    }

    /**
     * The Cloud resource with which this support account is associated.
     *
     * Generated from protobuf field <code>string cloud_resource = 3;</code>
     * @return string
     */
    public function getCloudResource()
    {
        return $this->cloud_resource;
    }

    /**
     * The Cloud resource with which this support account is associated.
     *
     * Generated from protobuf field <code>string cloud_resource = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setCloudResource($var)
    {
        GPBUtil::checkString($var, True);
        $this->cloud_resource = $var;

        return $this;
    }

    /**
     * A user friendly display name assigned to this support account.
     *
     * Generated from protobuf field <code>string display_name = 4;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * A user friendly display name assigned to this support account.
     *
     * Generated from protobuf field <code>string display_name = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Indicates the current state of an account.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.SupportAccount.State state = 5;</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Indicates the current state of an account.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.SupportAccount.State state = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Support\Common\SupportAccount_State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Time when this account was created.
     * Output only.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 6;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    /**
     * Time when this account was created.
     * Output only.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 6;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * The resource name of a billing account associated with this support
     * account. For example, `billingAccounts/ABCDEF-012345-567890`.
     *
     * Generated from protobuf field <code>string billing_account_name = 7;</code>
     * @return string
     */
    public function getBillingAccountName()
    {
        return $this->billing_account_name;
    }

    /**
     * The resource name of a billing account associated with this support
     * account. For example, `billingAccounts/ABCDEF-012345-567890`.
     *
     * Generated from protobuf field <code>string billing_account_name = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setBillingAccountName($var)
    {
        GPBUtil::checkString($var, True);
        $this->billing_account_name = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>string unify_account_id = 8;</code>
     * @return string
     */
    public function getUnifyAccountId()
    {
        return $this->unify_account_id;
    }

    /**
     * Generated from protobuf field <code>string unify_account_id = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setUnifyAccountId($var)
    {
        GPBUtil::checkString($var, True);
        $this->unify_account_id = $var;

        return $this;
    }

    /**
     * The PricingModel applicable to this support account.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.SupportAccount.PricingModel pricing_model = 9;</code>
     * @return int
     */
    public function getPricingModel()
    {
        return $this->pricing_model;
    }

    /**
     * The PricingModel applicable to this support account.
     *
     * Generated from protobuf field <code>.google.cloud.support.common.SupportAccount.PricingModel pricing_model = 9;</code>
     * @param int $var
     * @return $this
     */
    public function setPricingModel($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Support\Common\SupportAccount_PricingModel::class);
        $this->pricing_model = $var;

        return $this;
    }

}

