<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/devtools/remoteworkers/v1test2/tasks.proto

namespace Google\Devtools\Remoteworkers\V1test2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A Task represents a unit of work. Its result and logs are defined as
 * subresources.
 * If all the `Any` fields are populated, this can be a very large message, and
 * clients may not want the entire message returned on every call to every
 * method. Such clients should request partial responses
 * (https://cloud.google.com/apis/design/design_patterns#partial_response) and
 * servers should implement partial responses in order to reduce unnecessry
 * overhead.
 *
 * Generated from protobuf message <code>google.devtools.remoteworkers.v1test2.Task</code>
 */
class Task extends \Google\Protobuf\Internal\Message
{
    /**
     * The name of this task. Output only.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    private $name = '';
    /**
     * The actual task to perform. For example, this could be CommandTask to run a
     * command line.
     *
     * Generated from protobuf field <code>.google.protobuf.Any description = 2;</code>
     */
    private $description = null;
    /**
     * Handles to logs. The key is a human-readable name like `stdout`, and the
     * handle is a resource name that can be passed to ByteStream or other
     * accessors.
     * An implementation may define some logs by default (like `stdout`), and may
     * allow clients to add new logs via AddTaskLog.
     *
     * Generated from protobuf field <code>map<string, string> logs = 3;</code>
     */
    private $logs;

    public function __construct() {
        \GPBMetadata\Google\Devtools\Remoteworkers\V1Test2\Tasks::initOnce();
        parent::__construct();
    }

    /**
     * The name of this task. Output only.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The name of this task. Output only.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The actual task to perform. For example, this could be CommandTask to run a
     * command line.
     *
     * Generated from protobuf field <code>.google.protobuf.Any description = 2;</code>
     * @return \Google\Protobuf\Any
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * The actual task to perform. For example, this could be CommandTask to run a
     * command line.
     *
     * Generated from protobuf field <code>.google.protobuf.Any description = 2;</code>
     * @param \Google\Protobuf\Any $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Any::class);
        $this->description = $var;

        return $this;
    }

    /**
     * Handles to logs. The key is a human-readable name like `stdout`, and the
     * handle is a resource name that can be passed to ByteStream or other
     * accessors.
     * An implementation may define some logs by default (like `stdout`), and may
     * allow clients to add new logs via AddTaskLog.
     *
     * Generated from protobuf field <code>map<string, string> logs = 3;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLogs()
    {
        return $this->logs;
    }

    /**
     * Handles to logs. The key is a human-readable name like `stdout`, and the
     * handle is a resource name that can be passed to ByteStream or other
     * accessors.
     * An implementation may define some logs by default (like `stdout`), and may
     * allow clients to add new logs via AddTaskLog.
     *
     * Generated from protobuf field <code>map<string, string> logs = 3;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLogs($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->logs = $arr;

        return $this;
    }

}

