<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/streetview/publish/v1/rpcmessages.proto

namespace Google\Streetview\Publish\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request to list all photos that belong to the user sending the request.
 * By default
 * - does not return the download URL for the photo bytes.
 * Parameters:
 * - 'view' controls if the download URL for the photo bytes will be returned.
 * - 'page_size' determines the maximum number of photos to return.
 * - 'page_token' is the next page token value returned from a previous List
 *     request, if any.
 *
 * Generated from protobuf message <code>google.streetview.publish.v1.ListPhotosRequest</code>
 */
class ListPhotosRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Specifies if a download URL for the photos bytes should be returned in the
     * Photos response.
     *
     * Generated from protobuf field <code>.google.streetview.publish.v1.PhotoView view = 1;</code>
     */
    private $view = 0;
    /**
     * The maximum number of photos to return.
     * `page_size` must be non-negative. If `page_size` is zero or is not
     * provided, the default page size of 100 will be used.
     * The number of photos returned in the response may be less than `page_size`
     * if the number of photos that belong to the user is less than `page_size`.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    private $page_size = 0;
    /**
     * The next_page_token value returned from a previous List request, if any.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    private $page_token = '';
    /**
     * The filter expression.
     * Example: `placeId=ChIJj61dQgK6j4AR4GeTYWZsKWw`
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     */
    private $filter = '';

    public function __construct() {
        \GPBMetadata\Google\Streetview\Publish\V1\Rpcmessages::initOnce();
        parent::__construct();
    }

    /**
     * Specifies if a download URL for the photos bytes should be returned in the
     * Photos response.
     *
     * Generated from protobuf field <code>.google.streetview.publish.v1.PhotoView view = 1;</code>
     * @return int
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * Specifies if a download URL for the photos bytes should be returned in the
     * Photos response.
     *
     * Generated from protobuf field <code>.google.streetview.publish.v1.PhotoView view = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setView($var)
    {
        GPBUtil::checkEnum($var, \Google\Streetview\Publish\V1\PhotoView::class);
        $this->view = $var;

        return $this;
    }

    /**
     * The maximum number of photos to return.
     * `page_size` must be non-negative. If `page_size` is zero or is not
     * provided, the default page size of 100 will be used.
     * The number of photos returned in the response may be less than `page_size`
     * if the number of photos that belong to the user is less than `page_size`.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of photos to return.
     * `page_size` must be non-negative. If `page_size` is zero or is not
     * provided, the default page size of 100 will be used.
     * The number of photos returned in the response may be less than `page_size`
     * if the number of photos that belong to the user is less than `page_size`.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * The next_page_token value returned from a previous List request, if any.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * The next_page_token value returned from a previous List request, if any.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * The filter expression.
     * Example: `placeId=ChIJj61dQgK6j4AR4GeTYWZsKWw`
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * The filter expression.
     * Example: `placeId=ChIJj61dQgK6j4AR4GeTYWZsKWw`
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

