<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/genomics/v1/variants.proto

namespace Google\Genomics\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A call set is a collection of variant calls, typically for one sample. It
 * belongs to a variant set.
 * For more genomics resource definitions, see [Fundamentals of Google
 * Genomics](https://cloud.google.com/genomics/fundamentals-of-google-genomics)
 *
 * Generated from protobuf message <code>google.genomics.v1.CallSet</code>
 */
class CallSet extends \Google\Protobuf\Internal\Message
{
    /**
     * The server-generated call set ID, unique across all call sets.
     *
     * Generated from protobuf field <code>string id = 1;</code>
     */
    private $id = '';
    /**
     * The call set name.
     *
     * Generated from protobuf field <code>string name = 2;</code>
     */
    private $name = '';
    /**
     * The sample ID this call set corresponds to.
     *
     * Generated from protobuf field <code>string sample_id = 7;</code>
     */
    private $sample_id = '';
    /**
     * The IDs of the variant sets this call set belongs to. This field must
     * have exactly length one, as a call set belongs to a single variant set.
     * This field is repeated for compatibility with the
     * [GA4GH 0.5.1
     * API](https://github.com/ga4gh/schemas/blob/v0.5.1/src/main/resources/avro/variants.avdl#L76).
     *
     * Generated from protobuf field <code>repeated string variant_set_ids = 6;</code>
     */
    private $variant_set_ids;
    /**
     * The date this call set was created in milliseconds from the epoch.
     *
     * Generated from protobuf field <code>int64 created = 5;</code>
     */
    private $created = 0;
    /**
     * A map of additional call set information. This must be of the form
     * map<string, string[]> (string key mapping to a list of string values).
     *
     * Generated from protobuf field <code>map<string, .google.protobuf.ListValue> info = 4;</code>
     */
    private $info;

    public function __construct() {
        \GPBMetadata\Google\Genomics\V1\Variants::initOnce();
        parent::__construct();
    }

    /**
     * The server-generated call set ID, unique across all call sets.
     *
     * Generated from protobuf field <code>string id = 1;</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * The server-generated call set ID, unique across all call sets.
     *
     * Generated from protobuf field <code>string id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * The call set name.
     *
     * Generated from protobuf field <code>string name = 2;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The call set name.
     *
     * Generated from protobuf field <code>string name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The sample ID this call set corresponds to.
     *
     * Generated from protobuf field <code>string sample_id = 7;</code>
     * @return string
     */
    public function getSampleId()
    {
        return $this->sample_id;
    }

    /**
     * The sample ID this call set corresponds to.
     *
     * Generated from protobuf field <code>string sample_id = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setSampleId($var)
    {
        GPBUtil::checkString($var, True);
        $this->sample_id = $var;

        return $this;
    }

    /**
     * The IDs of the variant sets this call set belongs to. This field must
     * have exactly length one, as a call set belongs to a single variant set.
     * This field is repeated for compatibility with the
     * [GA4GH 0.5.1
     * API](https://github.com/ga4gh/schemas/blob/v0.5.1/src/main/resources/avro/variants.avdl#L76).
     *
     * Generated from protobuf field <code>repeated string variant_set_ids = 6;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getVariantSetIds()
    {
        return $this->variant_set_ids;
    }

    /**
     * The IDs of the variant sets this call set belongs to. This field must
     * have exactly length one, as a call set belongs to a single variant set.
     * This field is repeated for compatibility with the
     * [GA4GH 0.5.1
     * API](https://github.com/ga4gh/schemas/blob/v0.5.1/src/main/resources/avro/variants.avdl#L76).
     *
     * Generated from protobuf field <code>repeated string variant_set_ids = 6;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setVariantSetIds($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->variant_set_ids = $arr;

        return $this;
    }

    /**
     * The date this call set was created in milliseconds from the epoch.
     *
     * Generated from protobuf field <code>int64 created = 5;</code>
     * @return int|string
     */
    public function getCreated()
    {
        return $this->created;
    }

    /**
     * The date this call set was created in milliseconds from the epoch.
     *
     * Generated from protobuf field <code>int64 created = 5;</code>
     * @param int|string $var
     * @return $this
     */
    public function setCreated($var)
    {
        GPBUtil::checkInt64($var);
        $this->created = $var;

        return $this;
    }

    /**
     * A map of additional call set information. This must be of the form
     * map<string, string[]> (string key mapping to a list of string values).
     *
     * Generated from protobuf field <code>map<string, .google.protobuf.ListValue> info = 4;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getInfo()
    {
        return $this->info;
    }

    /**
     * A map of additional call set information. This must be of the form
     * map<string, string[]> (string key mapping to a list of string values).
     *
     * Generated from protobuf field <code>map<string, .google.protobuf.ListValue> info = 4;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setInfo($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Protobuf\ListValue::class);
        $this->info = $arr;

        return $this;
    }

}

