<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/genomics/v1/reads.proto

namespace Google\Genomics\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The read group set import request.
 *
 * Generated from protobuf message <code>google.genomics.v1.ImportReadGroupSetsRequest</code>
 */
class ImportReadGroupSetsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The ID of the dataset these read group sets will belong to. The
     * caller must have WRITE permissions to this dataset.
     *
     * Generated from protobuf field <code>string dataset_id = 1;</code>
     */
    private $dataset_id = '';
    /**
     * The reference set to which the imported read group sets are aligned to, if
     * any. The reference names of this reference set must be a superset of those
     * found in the imported file headers. If no reference set id is provided, a
     * best effort is made to associate with a matching reference set.
     *
     * Generated from protobuf field <code>string reference_set_id = 4;</code>
     */
    private $reference_set_id = '';
    /**
     * A list of URIs pointing at [BAM
     * files](https://samtools.github.io/hts-specs/SAMv1.pdf)
     * in Google Cloud Storage.
     * Those URIs can include wildcards (*), but do not add or remove
     * matching files before import has completed.
     * Note that Google Cloud Storage object listing is only eventually
     * consistent: files added may be not be immediately visible to
     * everyone. Thus, if using a wildcard it is preferable not to start
     * the import immediately after the files are created.
     *
     * Generated from protobuf field <code>repeated string source_uris = 2;</code>
     */
    private $source_uris;
    /**
     * The partition strategy describes how read groups are partitioned into read
     * group sets.
     *
     * Generated from protobuf field <code>.google.genomics.v1.ImportReadGroupSetsRequest.PartitionStrategy partition_strategy = 5;</code>
     */
    private $partition_strategy = 0;

    public function __construct() {
        \GPBMetadata\Google\Genomics\V1\Reads::initOnce();
        parent::__construct();
    }

    /**
     * Required. The ID of the dataset these read group sets will belong to. The
     * caller must have WRITE permissions to this dataset.
     *
     * Generated from protobuf field <code>string dataset_id = 1;</code>
     * @return string
     */
    public function getDatasetId()
    {
        return $this->dataset_id;
    }

    /**
     * Required. The ID of the dataset these read group sets will belong to. The
     * caller must have WRITE permissions to this dataset.
     *
     * Generated from protobuf field <code>string dataset_id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setDatasetId($var)
    {
        GPBUtil::checkString($var, True);
        $this->dataset_id = $var;

        return $this;
    }

    /**
     * The reference set to which the imported read group sets are aligned to, if
     * any. The reference names of this reference set must be a superset of those
     * found in the imported file headers. If no reference set id is provided, a
     * best effort is made to associate with a matching reference set.
     *
     * Generated from protobuf field <code>string reference_set_id = 4;</code>
     * @return string
     */
    public function getReferenceSetId()
    {
        return $this->reference_set_id;
    }

    /**
     * The reference set to which the imported read group sets are aligned to, if
     * any. The reference names of this reference set must be a superset of those
     * found in the imported file headers. If no reference set id is provided, a
     * best effort is made to associate with a matching reference set.
     *
     * Generated from protobuf field <code>string reference_set_id = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setReferenceSetId($var)
    {
        GPBUtil::checkString($var, True);
        $this->reference_set_id = $var;

        return $this;
    }

    /**
     * A list of URIs pointing at [BAM
     * files](https://samtools.github.io/hts-specs/SAMv1.pdf)
     * in Google Cloud Storage.
     * Those URIs can include wildcards (*), but do not add or remove
     * matching files before import has completed.
     * Note that Google Cloud Storage object listing is only eventually
     * consistent: files added may be not be immediately visible to
     * everyone. Thus, if using a wildcard it is preferable not to start
     * the import immediately after the files are created.
     *
     * Generated from protobuf field <code>repeated string source_uris = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSourceUris()
    {
        return $this->source_uris;
    }

    /**
     * A list of URIs pointing at [BAM
     * files](https://samtools.github.io/hts-specs/SAMv1.pdf)
     * in Google Cloud Storage.
     * Those URIs can include wildcards (*), but do not add or remove
     * matching files before import has completed.
     * Note that Google Cloud Storage object listing is only eventually
     * consistent: files added may be not be immediately visible to
     * everyone. Thus, if using a wildcard it is preferable not to start
     * the import immediately after the files are created.
     *
     * Generated from protobuf field <code>repeated string source_uris = 2;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSourceUris($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->source_uris = $arr;

        return $this;
    }

    /**
     * The partition strategy describes how read groups are partitioned into read
     * group sets.
     *
     * Generated from protobuf field <code>.google.genomics.v1.ImportReadGroupSetsRequest.PartitionStrategy partition_strategy = 5;</code>
     * @return int
     */
    public function getPartitionStrategy()
    {
        return $this->partition_strategy;
    }

    /**
     * The partition strategy describes how read groups are partitioned into read
     * group sets.
     *
     * Generated from protobuf field <code>.google.genomics.v1.ImportReadGroupSetsRequest.PartitionStrategy partition_strategy = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setPartitionStrategy($var)
    {
        GPBUtil::checkEnum($var, \Google\Genomics\V1\ImportReadGroupSetsRequest_PartitionStrategy::class);
        $this->partition_strategy = $var;

        return $this;
    }

}

