<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/genomics/v1/annotations.proto

namespace Google\Genomics\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Generated from protobuf message <code>google.genomics.v1.VariantAnnotation</code>
 */
class VariantAnnotation extends \Google\Protobuf\Internal\Message
{
    /**
     * Type has been adapted from ClinVar's list of variant types.
     *
     * Generated from protobuf field <code>.google.genomics.v1.VariantAnnotation.Type type = 1;</code>
     */
    private $type = 0;
    /**
     * Effect of the variant on the coding sequence.
     *
     * Generated from protobuf field <code>.google.genomics.v1.VariantAnnotation.Effect effect = 2;</code>
     */
    private $effect = 0;
    /**
     * The alternate allele for this variant. If multiple alternate alleles
     * exist at this location, create a separate variant for each one, as they
     * may represent distinct conditions.
     *
     * Generated from protobuf field <code>string alternate_bases = 3;</code>
     */
    private $alternate_bases = '';
    /**
     * Google annotation ID of the gene affected by this variant. This should
     * be provided when the variant is created.
     *
     * Generated from protobuf field <code>string gene_id = 4;</code>
     */
    private $gene_id = '';
    /**
     * Google annotation IDs of the transcripts affected by this variant. These
     * should be provided when the variant is created.
     *
     * Generated from protobuf field <code>repeated string transcript_ids = 5;</code>
     */
    private $transcript_ids;
    /**
     * The set of conditions associated with this variant.
     * A condition describes the way a variant influences human health.
     *
     * Generated from protobuf field <code>repeated .google.genomics.v1.VariantAnnotation.ClinicalCondition conditions = 6;</code>
     */
    private $conditions;
    /**
     * Describes the clinical significance of a variant.
     * It is adapted from the ClinVar controlled vocabulary for clinical
     * significance described at:
     * http://www.ncbi.nlm.nih.gov/clinvar/docs/clinsig/
     *
     * Generated from protobuf field <code>.google.genomics.v1.VariantAnnotation.ClinicalSignificance clinical_significance = 7;</code>
     */
    private $clinical_significance = 0;

    public function __construct() {
        \GPBMetadata\Google\Genomics\V1\Annotations::initOnce();
        parent::__construct();
    }

    /**
     * Type has been adapted from ClinVar's list of variant types.
     *
     * Generated from protobuf field <code>.google.genomics.v1.VariantAnnotation.Type type = 1;</code>
     * @return int
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * Type has been adapted from ClinVar's list of variant types.
     *
     * Generated from protobuf field <code>.google.genomics.v1.VariantAnnotation.Type type = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setType($var)
    {
        GPBUtil::checkEnum($var, \Google\Genomics\V1\VariantAnnotation_Type::class);
        $this->type = $var;

        return $this;
    }

    /**
     * Effect of the variant on the coding sequence.
     *
     * Generated from protobuf field <code>.google.genomics.v1.VariantAnnotation.Effect effect = 2;</code>
     * @return int
     */
    public function getEffect()
    {
        return $this->effect;
    }

    /**
     * Effect of the variant on the coding sequence.
     *
     * Generated from protobuf field <code>.google.genomics.v1.VariantAnnotation.Effect effect = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setEffect($var)
    {
        GPBUtil::checkEnum($var, \Google\Genomics\V1\VariantAnnotation_Effect::class);
        $this->effect = $var;

        return $this;
    }

    /**
     * The alternate allele for this variant. If multiple alternate alleles
     * exist at this location, create a separate variant for each one, as they
     * may represent distinct conditions.
     *
     * Generated from protobuf field <code>string alternate_bases = 3;</code>
     * @return string
     */
    public function getAlternateBases()
    {
        return $this->alternate_bases;
    }

    /**
     * The alternate allele for this variant. If multiple alternate alleles
     * exist at this location, create a separate variant for each one, as they
     * may represent distinct conditions.
     *
     * Generated from protobuf field <code>string alternate_bases = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setAlternateBases($var)
    {
        GPBUtil::checkString($var, True);
        $this->alternate_bases = $var;

        return $this;
    }

    /**
     * Google annotation ID of the gene affected by this variant. This should
     * be provided when the variant is created.
     *
     * Generated from protobuf field <code>string gene_id = 4;</code>
     * @return string
     */
    public function getGeneId()
    {
        return $this->gene_id;
    }

    /**
     * Google annotation ID of the gene affected by this variant. This should
     * be provided when the variant is created.
     *
     * Generated from protobuf field <code>string gene_id = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setGeneId($var)
    {
        GPBUtil::checkString($var, True);
        $this->gene_id = $var;

        return $this;
    }

    /**
     * Google annotation IDs of the transcripts affected by this variant. These
     * should be provided when the variant is created.
     *
     * Generated from protobuf field <code>repeated string transcript_ids = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTranscriptIds()
    {
        return $this->transcript_ids;
    }

    /**
     * Google annotation IDs of the transcripts affected by this variant. These
     * should be provided when the variant is created.
     *
     * Generated from protobuf field <code>repeated string transcript_ids = 5;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTranscriptIds($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->transcript_ids = $arr;

        return $this;
    }

    /**
     * The set of conditions associated with this variant.
     * A condition describes the way a variant influences human health.
     *
     * Generated from protobuf field <code>repeated .google.genomics.v1.VariantAnnotation.ClinicalCondition conditions = 6;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getConditions()
    {
        return $this->conditions;
    }

    /**
     * The set of conditions associated with this variant.
     * A condition describes the way a variant influences human health.
     *
     * Generated from protobuf field <code>repeated .google.genomics.v1.VariantAnnotation.ClinicalCondition conditions = 6;</code>
     * @param \Google\Genomics\V1\VariantAnnotation_ClinicalCondition[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setConditions($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Genomics\V1\VariantAnnotation_ClinicalCondition::class);
        $this->conditions = $arr;

        return $this;
    }

    /**
     * Describes the clinical significance of a variant.
     * It is adapted from the ClinVar controlled vocabulary for clinical
     * significance described at:
     * http://www.ncbi.nlm.nih.gov/clinvar/docs/clinsig/
     *
     * Generated from protobuf field <code>.google.genomics.v1.VariantAnnotation.ClinicalSignificance clinical_significance = 7;</code>
     * @return int
     */
    public function getClinicalSignificance()
    {
        return $this->clinical_significance;
    }

    /**
     * Describes the clinical significance of a variant.
     * It is adapted from the ClinVar controlled vocabulary for clinical
     * significance described at:
     * http://www.ncbi.nlm.nih.gov/clinvar/docs/clinsig/
     *
     * Generated from protobuf field <code>.google.genomics.v1.VariantAnnotation.ClinicalSignificance clinical_significance = 7;</code>
     * @param int $var
     * @return $this
     */
    public function setClinicalSignificance($var)
    {
        GPBUtil::checkEnum($var, \Google\Genomics\V1\VariantAnnotation_ClinicalSignificance::class);
        $this->clinical_significance = $var;

        return $this;
    }

}

