<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/genomics/v1alpha2/pipelines.proto

namespace Google\Genomics\V1alpha2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The system resources for the pipeline run.
 *
 * Generated from protobuf message <code>google.genomics.v1alpha2.PipelineResources</code>
 */
class PipelineResources extends \Google\Protobuf\Internal\Message
{
    /**
     * The minimum number of cores to use. Defaults to 1.
     *
     * Generated from protobuf field <code>int32 minimum_cpu_cores = 1;</code>
     */
    private $minimum_cpu_cores = 0;
    /**
     * Whether to use preemptible VMs. Defaults to `false`. In order to use this,
     * must be true for both create time and run time. Cannot be true at run time
     * if false at create time.
     *
     * Generated from protobuf field <code>bool preemptible = 2;</code>
     */
    private $preemptible = false;
    /**
     * The minimum amount of RAM to use. Defaults to 3.75 (GB)
     *
     * Generated from protobuf field <code>double minimum_ram_gb = 3;</code>
     */
    private $minimum_ram_gb = 0.0;
    /**
     * Disks to attach.
     *
     * Generated from protobuf field <code>repeated .google.genomics.v1alpha2.PipelineResources.Disk disks = 4;</code>
     */
    private $disks;
    /**
     * List of Google Compute Engine availability zones to which resource
     * creation will restricted. If empty, any zone may be chosen.
     *
     * Generated from protobuf field <code>repeated string zones = 5;</code>
     */
    private $zones;
    /**
     * The size of the boot disk. Defaults to 10 (GB).
     *
     * Generated from protobuf field <code>int32 boot_disk_size_gb = 6;</code>
     */
    private $boot_disk_size_gb = 0;
    /**
     * Whether to assign an external IP to the instance. This is an experimental
     * feature that may go away. Defaults to false.
     * Corresponds to `--no_address` flag for [gcloud compute instances create]
     * (https://cloud.google.com/sdk/gcloud/reference/compute/instances/create).
     * In order to use this, must be true for both create time and run time.
     * Cannot be true at run time if false at create time. If you need to ssh into
     * a private IP VM for debugging, you can ssh to a public VM and then ssh into
     * the private VM's Internal IP.  If noAddress is set, this pipeline run may
     * only load docker images from Google Container Registry and not Docker Hub.
     * ** Note: To use this option, your project must be in Google Access for
     * Private IPs Early Access Program.**
     *
     * Generated from protobuf field <code>bool no_address = 7;</code>
     */
    private $no_address = false;

    public function __construct() {
        \GPBMetadata\Google\Genomics\V1Alpha2\Pipelines::initOnce();
        parent::__construct();
    }

    /**
     * The minimum number of cores to use. Defaults to 1.
     *
     * Generated from protobuf field <code>int32 minimum_cpu_cores = 1;</code>
     * @return int
     */
    public function getMinimumCpuCores()
    {
        return $this->minimum_cpu_cores;
    }

    /**
     * The minimum number of cores to use. Defaults to 1.
     *
     * Generated from protobuf field <code>int32 minimum_cpu_cores = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setMinimumCpuCores($var)
    {
        GPBUtil::checkInt32($var);
        $this->minimum_cpu_cores = $var;

        return $this;
    }

    /**
     * Whether to use preemptible VMs. Defaults to `false`. In order to use this,
     * must be true for both create time and run time. Cannot be true at run time
     * if false at create time.
     *
     * Generated from protobuf field <code>bool preemptible = 2;</code>
     * @return bool
     */
    public function getPreemptible()
    {
        return $this->preemptible;
    }

    /**
     * Whether to use preemptible VMs. Defaults to `false`. In order to use this,
     * must be true for both create time and run time. Cannot be true at run time
     * if false at create time.
     *
     * Generated from protobuf field <code>bool preemptible = 2;</code>
     * @param bool $var
     * @return $this
     */
    public function setPreemptible($var)
    {
        GPBUtil::checkBool($var);
        $this->preemptible = $var;

        return $this;
    }

    /**
     * The minimum amount of RAM to use. Defaults to 3.75 (GB)
     *
     * Generated from protobuf field <code>double minimum_ram_gb = 3;</code>
     * @return float
     */
    public function getMinimumRamGb()
    {
        return $this->minimum_ram_gb;
    }

    /**
     * The minimum amount of RAM to use. Defaults to 3.75 (GB)
     *
     * Generated from protobuf field <code>double minimum_ram_gb = 3;</code>
     * @param float $var
     * @return $this
     */
    public function setMinimumRamGb($var)
    {
        GPBUtil::checkDouble($var);
        $this->minimum_ram_gb = $var;

        return $this;
    }

    /**
     * Disks to attach.
     *
     * Generated from protobuf field <code>repeated .google.genomics.v1alpha2.PipelineResources.Disk disks = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getDisks()
    {
        return $this->disks;
    }

    /**
     * Disks to attach.
     *
     * Generated from protobuf field <code>repeated .google.genomics.v1alpha2.PipelineResources.Disk disks = 4;</code>
     * @param \Google\Genomics\V1alpha2\PipelineResources_Disk[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setDisks($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Genomics\V1alpha2\PipelineResources_Disk::class);
        $this->disks = $arr;

        return $this;
    }

    /**
     * List of Google Compute Engine availability zones to which resource
     * creation will restricted. If empty, any zone may be chosen.
     *
     * Generated from protobuf field <code>repeated string zones = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getZones()
    {
        return $this->zones;
    }

    /**
     * List of Google Compute Engine availability zones to which resource
     * creation will restricted. If empty, any zone may be chosen.
     *
     * Generated from protobuf field <code>repeated string zones = 5;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setZones($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->zones = $arr;

        return $this;
    }

    /**
     * The size of the boot disk. Defaults to 10 (GB).
     *
     * Generated from protobuf field <code>int32 boot_disk_size_gb = 6;</code>
     * @return int
     */
    public function getBootDiskSizeGb()
    {
        return $this->boot_disk_size_gb;
    }

    /**
     * The size of the boot disk. Defaults to 10 (GB).
     *
     * Generated from protobuf field <code>int32 boot_disk_size_gb = 6;</code>
     * @param int $var
     * @return $this
     */
    public function setBootDiskSizeGb($var)
    {
        GPBUtil::checkInt32($var);
        $this->boot_disk_size_gb = $var;

        return $this;
    }

    /**
     * Whether to assign an external IP to the instance. This is an experimental
     * feature that may go away. Defaults to false.
     * Corresponds to `--no_address` flag for [gcloud compute instances create]
     * (https://cloud.google.com/sdk/gcloud/reference/compute/instances/create).
     * In order to use this, must be true for both create time and run time.
     * Cannot be true at run time if false at create time. If you need to ssh into
     * a private IP VM for debugging, you can ssh to a public VM and then ssh into
     * the private VM's Internal IP.  If noAddress is set, this pipeline run may
     * only load docker images from Google Container Registry and not Docker Hub.
     * ** Note: To use this option, your project must be in Google Access for
     * Private IPs Early Access Program.**
     *
     * Generated from protobuf field <code>bool no_address = 7;</code>
     * @return bool
     */
    public function getNoAddress()
    {
        return $this->no_address;
    }

    /**
     * Whether to assign an external IP to the instance. This is an experimental
     * feature that may go away. Defaults to false.
     * Corresponds to `--no_address` flag for [gcloud compute instances create]
     * (https://cloud.google.com/sdk/gcloud/reference/compute/instances/create).
     * In order to use this, must be true for both create time and run time.
     * Cannot be true at run time if false at create time. If you need to ssh into
     * a private IP VM for debugging, you can ssh to a public VM and then ssh into
     * the private VM's Internal IP.  If noAddress is set, this pipeline run may
     * only load docker images from Google Container Registry and not Docker Hub.
     * ** Note: To use this option, your project must be in Google Access for
     * Private IPs Early Access Program.**
     *
     * Generated from protobuf field <code>bool no_address = 7;</code>
     * @param bool $var
     * @return $this
     */
    public function setNoAddress($var)
    {
        GPBUtil::checkBool($var);
        $this->no_address = $var;

        return $this;
    }

}

