<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/genomics/v1alpha2/pipelines.proto

namespace Google\Genomics\V1alpha2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The pipeline run arguments.
 *
 * Generated from protobuf message <code>google.genomics.v1alpha2.RunPipelineArgs</code>
 */
class RunPipelineArgs extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The project in which to run the pipeline. The caller must have
     * WRITER access to all Google Cloud services and resources (e.g. Google
     * Compute Engine) will be used.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     */
    private $project_id = '';
    /**
     * Pipeline input arguments; keys are defined in the pipeline documentation.
     * All input parameters that do not have default values  must be specified.
     * If parameters with defaults are specified here, the defaults will be
     * overridden.
     *
     * Generated from protobuf field <code>map<string, string> inputs = 2;</code>
     */
    private $inputs;
    /**
     * Pipeline output arguments; keys are defined in the pipeline
     * documentation.  All output parameters of without default values
     * must be specified.  If parameters with defaults are specified
     * here, the defaults will be overridden.
     *
     * Generated from protobuf field <code>map<string, string> outputs = 3;</code>
     */
    private $outputs;
    /**
     * The Google Cloud Service Account that will be used to access data and
     * services. By default, the compute service account associated with
     * `projectId` is used.
     *
     * Generated from protobuf field <code>.google.genomics.v1alpha2.ServiceAccount service_account = 4;</code>
     */
    private $service_account = null;
    /**
     * This field is deprecated. Use `labels` instead. Client-specified pipeline
     * operation identifier.
     *
     * Generated from protobuf field <code>string client_id = 5;</code>
     */
    private $client_id = '';
    /**
     * Specifies resource requirements/overrides for the pipeline run.
     *
     * Generated from protobuf field <code>.google.genomics.v1alpha2.PipelineResources resources = 6;</code>
     */
    private $resources = null;
    /**
     * Required. Logging options. Used by the service to communicate results
     * to the user.
     *
     * Generated from protobuf field <code>.google.genomics.v1alpha2.LoggingOptions logging = 7;</code>
     */
    private $logging = null;
    /**
     * How long to keep the VM up after a failure (for example docker command
     * failed, copying input or output files failed, etc). While the VM is up, one
     * can ssh into the VM to debug. Default is 0; maximum allowed value is 1 day.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration keep_vm_alive_on_failure_duration = 8;</code>
     */
    private $keep_vm_alive_on_failure_duration = null;
    /**
     * Labels to apply to this pipeline run. Labels will also be applied to
     * compute resources (VM, disks) created by this pipeline run. When listing
     * operations, operations can [filtered by labels]
     * [google.longrunning.ListOperationsRequest.filter].
     * Label keys may not be empty; label values may be empty. Non-empty labels
     * must be 1-63 characters long, and comply with [RFC1035]
     * (https://www.ietf.org/rfc/rfc1035.txt).
     * Specifically, the name must be 1-63 characters long and match the regular
     * expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first
     * character must be a lowercase letter, and all following characters must be
     * a dash, lowercase letter, or digit, except the last character, which cannot
     * be a dash.
     *
     * Generated from protobuf field <code>map<string, string> labels = 9;</code>
     */
    private $labels;

    public function __construct() {
        \GPBMetadata\Google\Genomics\V1Alpha2\Pipelines::initOnce();
        parent::__construct();
    }

    /**
     * Required. The project in which to run the pipeline. The caller must have
     * WRITER access to all Google Cloud services and resources (e.g. Google
     * Compute Engine) will be used.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     * @return string
     */
    public function getProjectId()
    {
        return $this->project_id;
    }

    /**
     * Required. The project in which to run the pipeline. The caller must have
     * WRITER access to all Google Cloud services and resources (e.g. Google
     * Compute Engine) will be used.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->project_id = $var;

        return $this;
    }

    /**
     * Pipeline input arguments; keys are defined in the pipeline documentation.
     * All input parameters that do not have default values  must be specified.
     * If parameters with defaults are specified here, the defaults will be
     * overridden.
     *
     * Generated from protobuf field <code>map<string, string> inputs = 2;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getInputs()
    {
        return $this->inputs;
    }

    /**
     * Pipeline input arguments; keys are defined in the pipeline documentation.
     * All input parameters that do not have default values  must be specified.
     * If parameters with defaults are specified here, the defaults will be
     * overridden.
     *
     * Generated from protobuf field <code>map<string, string> inputs = 2;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setInputs($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->inputs = $arr;

        return $this;
    }

    /**
     * Pipeline output arguments; keys are defined in the pipeline
     * documentation.  All output parameters of without default values
     * must be specified.  If parameters with defaults are specified
     * here, the defaults will be overridden.
     *
     * Generated from protobuf field <code>map<string, string> outputs = 3;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getOutputs()
    {
        return $this->outputs;
    }

    /**
     * Pipeline output arguments; keys are defined in the pipeline
     * documentation.  All output parameters of without default values
     * must be specified.  If parameters with defaults are specified
     * here, the defaults will be overridden.
     *
     * Generated from protobuf field <code>map<string, string> outputs = 3;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setOutputs($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->outputs = $arr;

        return $this;
    }

    /**
     * The Google Cloud Service Account that will be used to access data and
     * services. By default, the compute service account associated with
     * `projectId` is used.
     *
     * Generated from protobuf field <code>.google.genomics.v1alpha2.ServiceAccount service_account = 4;</code>
     * @return \Google\Genomics\V1alpha2\ServiceAccount
     */
    public function getServiceAccount()
    {
        return $this->service_account;
    }

    /**
     * The Google Cloud Service Account that will be used to access data and
     * services. By default, the compute service account associated with
     * `projectId` is used.
     *
     * Generated from protobuf field <code>.google.genomics.v1alpha2.ServiceAccount service_account = 4;</code>
     * @param \Google\Genomics\V1alpha2\ServiceAccount $var
     * @return $this
     */
    public function setServiceAccount($var)
    {
        GPBUtil::checkMessage($var, \Google\Genomics\V1alpha2\ServiceAccount::class);
        $this->service_account = $var;

        return $this;
    }

    /**
     * This field is deprecated. Use `labels` instead. Client-specified pipeline
     * operation identifier.
     *
     * Generated from protobuf field <code>string client_id = 5;</code>
     * @return string
     */
    public function getClientId()
    {
        return $this->client_id;
    }

    /**
     * This field is deprecated. Use `labels` instead. Client-specified pipeline
     * operation identifier.
     *
     * Generated from protobuf field <code>string client_id = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setClientId($var)
    {
        GPBUtil::checkString($var, True);
        $this->client_id = $var;

        return $this;
    }

    /**
     * Specifies resource requirements/overrides for the pipeline run.
     *
     * Generated from protobuf field <code>.google.genomics.v1alpha2.PipelineResources resources = 6;</code>
     * @return \Google\Genomics\V1alpha2\PipelineResources
     */
    public function getResources()
    {
        return $this->resources;
    }

    /**
     * Specifies resource requirements/overrides for the pipeline run.
     *
     * Generated from protobuf field <code>.google.genomics.v1alpha2.PipelineResources resources = 6;</code>
     * @param \Google\Genomics\V1alpha2\PipelineResources $var
     * @return $this
     */
    public function setResources($var)
    {
        GPBUtil::checkMessage($var, \Google\Genomics\V1alpha2\PipelineResources::class);
        $this->resources = $var;

        return $this;
    }

    /**
     * Required. Logging options. Used by the service to communicate results
     * to the user.
     *
     * Generated from protobuf field <code>.google.genomics.v1alpha2.LoggingOptions logging = 7;</code>
     * @return \Google\Genomics\V1alpha2\LoggingOptions
     */
    public function getLogging()
    {
        return $this->logging;
    }

    /**
     * Required. Logging options. Used by the service to communicate results
     * to the user.
     *
     * Generated from protobuf field <code>.google.genomics.v1alpha2.LoggingOptions logging = 7;</code>
     * @param \Google\Genomics\V1alpha2\LoggingOptions $var
     * @return $this
     */
    public function setLogging($var)
    {
        GPBUtil::checkMessage($var, \Google\Genomics\V1alpha2\LoggingOptions::class);
        $this->logging = $var;

        return $this;
    }

    /**
     * How long to keep the VM up after a failure (for example docker command
     * failed, copying input or output files failed, etc). While the VM is up, one
     * can ssh into the VM to debug. Default is 0; maximum allowed value is 1 day.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration keep_vm_alive_on_failure_duration = 8;</code>
     * @return \Google\Protobuf\Duration
     */
    public function getKeepVmAliveOnFailureDuration()
    {
        return $this->keep_vm_alive_on_failure_duration;
    }

    /**
     * How long to keep the VM up after a failure (for example docker command
     * failed, copying input or output files failed, etc). While the VM is up, one
     * can ssh into the VM to debug. Default is 0; maximum allowed value is 1 day.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration keep_vm_alive_on_failure_duration = 8;</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setKeepVmAliveOnFailureDuration($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->keep_vm_alive_on_failure_duration = $var;

        return $this;
    }

    /**
     * Labels to apply to this pipeline run. Labels will also be applied to
     * compute resources (VM, disks) created by this pipeline run. When listing
     * operations, operations can [filtered by labels]
     * [google.longrunning.ListOperationsRequest.filter].
     * Label keys may not be empty; label values may be empty. Non-empty labels
     * must be 1-63 characters long, and comply with [RFC1035]
     * (https://www.ietf.org/rfc/rfc1035.txt).
     * Specifically, the name must be 1-63 characters long and match the regular
     * expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first
     * character must be a lowercase letter, and all following characters must be
     * a dash, lowercase letter, or digit, except the last character, which cannot
     * be a dash.
     *
     * Generated from protobuf field <code>map<string, string> labels = 9;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels to apply to this pipeline run. Labels will also be applied to
     * compute resources (VM, disks) created by this pipeline run. When listing
     * operations, operations can [filtered by labels]
     * [google.longrunning.ListOperationsRequest.filter].
     * Label keys may not be empty; label values may be empty. Non-empty labels
     * must be 1-63 characters long, and comply with [RFC1035]
     * (https://www.ietf.org/rfc/rfc1035.txt).
     * Specifically, the name must be 1-63 characters long and match the regular
     * expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first
     * character must be a lowercase letter, and all following characters must be
     * a dash, lowercase letter, or digit, except the last character, which cannot
     * be a dash.
     *
     * Generated from protobuf field <code>map<string, string> labels = 9;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

}

